/********************************************************************************
 * Copyright (c) 2024 EclipseSource and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the Eclipse
 * Public License v. 2.0 are satisfied: GNU General Public License, version 2
 * with the GNU Classpath Exception which is available at
 * https://www.gnu.org/software/classpath/license.html.
 *
 * SPDX-License-Identifier: EPL-2.0 OR GPL-2.0 WITH Classpath-exception-2.0
 ********************************************************************************/

export enum PNMLModelTypes {
    PLACE = 'place',
    TRANSITION = 'transition',
    ARC = 'arc',
    PAGE = 'page',
    PAGE_NODE = 'pageNode',
    REF_PLACE = 'referencePlace',
    REF_TRANSITION = 'referenceTransition',
    REFERENCE = 'reference',
    INHIBITOR_ARC = 'inhibitorArc',
    READ_ARC = 'readArc',

    GRAPH = 'graph',
    NAME_LABEL = 'nameLabel',
    MARKING_LABEL = 'markingLabel',
    ARC_LABEL = 'arcWeightLabel',

    // DiNeROS types
    TOPIC_TRANSITION = 'topicTransitionType',
    TOPIC_LINK = 'topicLink',
    SERVICE_TRANSITION = 'serviceTransitionType',
    SERVICE_CHANNEL = 'serviceChannel',
    SERVICE_CHANNEL_LINK = 'serviceChannelLink',
    SERVER_PAGE = 'serverPrototype',
    SERVICE_SERVER_LINK = 'serviceServerLink',

    NODE_PAGE_NODE = 'nodePageNode'
}
