/**
 */
package org.pnml.emf.ptnet;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Font Decoration</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.pnml.emf.ptnet.PtnetPackage#getFontDecoration()
 * @model
 * @generated
 */
public enum FontDecoration implements Enumerator {
   /**
    * The '<em><b>UNDERLINE</b></em>' literal object.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #UNDERLINE_VALUE
    * @generated
    * @ordered
    */
   UNDERLINE(0, "UNDERLINE", "underline"),

   /**
    * The '<em><b>OVERLINE</b></em>' literal object.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #OVERLINE_VALUE
    * @generated
    * @ordered
    */
   OVERLINE(1, "OVERLINE", "overline"),

   /**
    * The '<em><b>LINETHROUGH</b></em>' literal object.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #LINETHROUGH_VALUE
    * @generated
    * @ordered
    */
   LINETHROUGH(2, "LINETHROUGH", "linethrough");

   /**
    * The '<em><b>UNDERLINE</b></em>' literal value.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #UNDERLINE
    * @model literal="underline"
    * @generated
    * @ordered
    */
   public static final int UNDERLINE_VALUE = 0;

   /**
    * The '<em><b>OVERLINE</b></em>' literal value.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #OVERLINE
    * @model literal="overline"
    * @generated
    * @ordered
    */
   public static final int OVERLINE_VALUE = 1;

   /**
    * The '<em><b>LINETHROUGH</b></em>' literal value.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #LINETHROUGH
    * @model literal="linethrough"
    * @generated
    * @ordered
    */
   public static final int LINETHROUGH_VALUE = 2;

   /**
    * An array of all the '<em><b>Font Decoration</b></em>' enumerators.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private static final FontDecoration[] VALUES_ARRAY = new FontDecoration[] {
      UNDERLINE,
      OVERLINE,
      LINETHROUGH,
   };

   /**
    * A public read-only list of all the '<em><b>Font Decoration</b></em>' enumerators.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public static final List<FontDecoration> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

   /**
    * Returns the '<em><b>Font Decoration</b></em>' literal with the specified literal value.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param literal the literal.
    * @return the matching enumerator or <code>null</code>.
    * @generated
    */
   public static FontDecoration get(String literal) {
      for (int i = 0; i < VALUES_ARRAY.length; ++i) {
         FontDecoration result = VALUES_ARRAY[i];
         if (result.toString().equals(literal)) {
            return result;
         }
      }
      return null;
   }

   /**
    * Returns the '<em><b>Font Decoration</b></em>' literal with the specified name.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param name the name.
    * @return the matching enumerator or <code>null</code>.
    * @generated
    */
   public static FontDecoration getByName(String name) {
      for (int i = 0; i < VALUES_ARRAY.length; ++i) {
         FontDecoration result = VALUES_ARRAY[i];
         if (result.getName().equals(name)) {
            return result;
         }
      }
      return null;
   }

   /**
    * Returns the '<em><b>Font Decoration</b></em>' literal with the specified integer value.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param value the integer value.
    * @return the matching enumerator or <code>null</code>.
    * @generated
    */
   public static FontDecoration get(int value) {
      switch (value) {
         case UNDERLINE_VALUE:
            return UNDERLINE;
         case OVERLINE_VALUE:
            return OVERLINE;
         case LINETHROUGH_VALUE:
            return LINETHROUGH;
      }
      return null;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private final int value;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private final String name;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private final String literal;

   /**
    * Only this class can construct instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private FontDecoration(int value, String name, String literal) {
      this.value = value;
      this.name = name;
      this.literal = literal;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int getValue() { return value; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String getName() { return name; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String getLiteral() { return literal; }

   /**
    * Returns the literal value of the enumerator, which is its string representation.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String toString() {
      return literal;
   }

} //FontDecoration
