/**
 */
package org.pnml.emf.ptnet;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Transition Node</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.pnml.emf.ptnet.TransitionNode#getReferencingTransitions <em>Referencing Transitions</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.TransitionNode#getInhibitorArcs <em>Inhibitor Arcs</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.TransitionNode#getReadArcs <em>Read Arcs</em>}</li>
 * </ul>
 *
 * @see org.pnml.emf.ptnet.PtnetPackage#getTransitionNode()
 * @model abstract="true"
 * @generated
 */
public interface TransitionNode extends Node {
   /**
    * Returns the value of the '<em><b>Referencing Transitions</b></em>' reference list.
    * The list contents are of type {@link org.pnml.emf.ptnet.RefTransition}.
    * It is bidirectional and its opposite is '{@link org.pnml.emf.ptnet.RefTransition#getRef <em>Ref</em>}'.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Referencing Transitions</em>' reference list.
    * @see org.pnml.emf.ptnet.PtnetPackage#getTransitionNode_ReferencingTransitions()
    * @see org.pnml.emf.ptnet.RefTransition#getRef
    * @model opposite="ref" changeable="false"
    * @generated
    */
   EList<RefTransition> getReferencingTransitions();

   /**
    * Returns the value of the '<em><b>Inhibitor Arcs</b></em>' reference list.
    * The list contents are of type {@link org.pnml.emf.ptnet.InhibitorArc}.
    * It is bidirectional and its opposite is '{@link org.pnml.emf.ptnet.InhibitorArc#getTarget <em>Target</em>}'.
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @return the value of the '<em>Inhibitor Arcs</em>' reference list.
    * @see org.pnml.emf.ptnet.PtnetPackage#getTransitionNode_InhibitorArcs()
    * @see org.pnml.emf.ptnet.InhibitorArc#getTarget
    * @model opposite="target" ordered="false"
    * @generated
    */
   EList<InhibitorArc> getInhibitorArcs();

   /**
    * Returns the value of the '<em><b>Read Arcs</b></em>' reference list.
    * The list contents are of type {@link org.pnml.emf.ptnet.ReadArc}.
    * It is bidirectional and its opposite is '{@link org.pnml.emf.ptnet.ReadArc#getTarget <em>Target</em>}'.
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @return the value of the '<em>Read Arcs</em>' reference list.
    * @see org.pnml.emf.ptnet.PtnetPackage#getTransitionNode_ReadArcs()
    * @see org.pnml.emf.ptnet.ReadArc#getTarget
    * @model opposite="target" ordered="false"
    * @generated
    */
   EList<ReadArc> getReadArcs();

} // TransitionNode
