/**
 */
package org.pnml.emf.ptnet.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.pnml.emf.ptnet.Annotation;
import org.pnml.emf.ptnet.AnnotationGraphics;
import org.pnml.emf.ptnet.AnyObject;
import org.pnml.emf.ptnet.Arc;
import org.pnml.emf.ptnet.ArcGraphics;
import org.pnml.emf.ptnet.Attribute;
import org.pnml.emf.ptnet.BalloonMarking;
import org.pnml.emf.ptnet.CSS2Color;
import org.pnml.emf.ptnet.CSS2FontFamily;
import org.pnml.emf.ptnet.CSS2FontSize;
import org.pnml.emf.ptnet.CSS2FontStyle;
import org.pnml.emf.ptnet.CSS2FontWeight;
import org.pnml.emf.ptnet.Channel;
import org.pnml.emf.ptnet.Channels;
import org.pnml.emf.ptnet.Coordinate;
import org.pnml.emf.ptnet.Dimension;
import org.pnml.emf.ptnet.Edge;
import org.pnml.emf.ptnet.Fill;
import org.pnml.emf.ptnet.Font;
import org.pnml.emf.ptnet.FontAlign;
import org.pnml.emf.ptnet.FontDecoration;
import org.pnml.emf.ptnet.Gradient;
import org.pnml.emf.ptnet.Graphics;
import org.pnml.emf.ptnet.InhibitorArc;
import org.pnml.emf.ptnet.InputSignal;
import org.pnml.emf.ptnet.InputSignals;
import org.pnml.emf.ptnet.Label;
import org.pnml.emf.ptnet.Line;
import org.pnml.emf.ptnet.LineShape;
import org.pnml.emf.ptnet.LineStyle;
import org.pnml.emf.ptnet.Name;
import org.pnml.emf.ptnet.Node;
import org.pnml.emf.ptnet.NodeGraphics;
import org.pnml.emf.ptnet.Offset;
import org.pnml.emf.ptnet.PNType;
import org.pnml.emf.ptnet.PTArcAnnotation;
import org.pnml.emf.ptnet.PTMarking;
import org.pnml.emf.ptnet.Page;
import org.pnml.emf.ptnet.PetriNet;
import org.pnml.emf.ptnet.Place;
import org.pnml.emf.ptnet.PlaceNode;
import org.pnml.emf.ptnet.PnObject;
import org.pnml.emf.ptnet.Position;
import org.pnml.emf.ptnet.PositionableObject;
import org.pnml.emf.ptnet.PtnetFactory;
import org.pnml.emf.ptnet.PtnetPackage;
import org.pnml.emf.ptnet.Publisher;
import org.pnml.emf.ptnet.Publishers;
import org.pnml.emf.ptnet.ReadArc;
import org.pnml.emf.ptnet.RefPlace;
import org.pnml.emf.ptnet.RefTransition;
import org.pnml.emf.ptnet.Subscriber;
import org.pnml.emf.ptnet.Subscribers;
import org.pnml.emf.ptnet.Tokens;
import org.pnml.emf.ptnet.ToolInfo;
import org.pnml.emf.ptnet.ToolInfoNet;
import org.pnml.emf.ptnet.ToolInfoNode;
import org.pnml.emf.ptnet.ToolInfoPage;
import org.pnml.emf.ptnet.ToolInfoPlace;
import org.pnml.emf.ptnet.ToolInfoTransition;
import org.pnml.emf.ptnet.Transition;
import org.pnml.emf.ptnet.TransitionNode;

import org.pnml.emf.ptnet.pnml;
import org.pnml.emf.ptnet.util.PtnetValidator;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class PtnetPackageImpl extends EPackageImpl implements PtnetPackage {
   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass ptMarkingEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass ptArcAnnotationEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass pnmlEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass petriNetEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass pageEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass pnObjectEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass nameEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass toolInfoEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass labelEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass nodeGraphicsEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass graphicsEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass coordinateEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass positionEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass offsetEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass dimensionEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass annotationGraphicsEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass fillEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass lineEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass arcGraphicsEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass arcEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass nodeEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass fontEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass placeNodeEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass transitionNodeEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass placeEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass refTransitionEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass transitionEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass refPlaceEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass attributeEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass annotationEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass anyObjectEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass edgeEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass inhibitorArcEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass readArcEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass positionableObjectEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass toolInfoPlaceEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass toolInfoTransitionEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass toolInfoPageEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass toolInfoNetEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass tokensEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass balloonMarkingEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass inputSignalsEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass inputSignalEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass channelsEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass channelEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass publishersEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass publisherEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass subscribersEClass = null;

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   private EClass subscriberEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass toolInfoNodeEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum pnTypeEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum css2ColorEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum gradientEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum lineShapeEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum fontAlignEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum fontDecorationEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum css2FontFamilyEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum css2FontSizeEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum css2FontStyleEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum css2FontWeightEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum lineStyleEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EDataType positiveIntegerEDataType = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EDataType naturalEDataType = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EDataType uriEDataType = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EDataType longStringEDataType = null;

   /**
    * Creates an instance of the model <b>Package</b>, registered with
    * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
    * package URI value.
    * <p>Note: the correct way to create the package is via the static
    * factory method {@link #init init()}, which also performs
    * initialization of the package, or returns the registered package,
    * if one already exists.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see org.eclipse.emf.ecore.EPackage.Registry
    * @see org.pnml.emf.ptnet.PtnetPackage#eNS_URI
    * @see #init()
    * @generated
    */
   private PtnetPackageImpl() {
      super(eNS_URI, PtnetFactory.eINSTANCE);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private static boolean isInited = false;

   /**
    * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
    *
    * <p>This method is used to initialize {@link PtnetPackage#eINSTANCE} when that field is accessed.
    * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #eNS_URI
    * @see #createPackageContents()
    * @see #initializePackageContents()
    * @generated
    */
   public static PtnetPackage init() {
      if (isInited)
         return (PtnetPackage) EPackage.Registry.INSTANCE.getEPackage(PtnetPackage.eNS_URI);

      // Obtain or create and register package
      Object registeredPtnetPackage = EPackage.Registry.INSTANCE.get(eNS_URI);
      PtnetPackageImpl thePtnetPackage = registeredPtnetPackage instanceof PtnetPackageImpl
         ? (PtnetPackageImpl) registeredPtnetPackage
         : new PtnetPackageImpl();

      isInited = true;

      // Create package meta-data objects
      thePtnetPackage.createPackageContents();

      // Initialize created meta-data
      thePtnetPackage.initializePackageContents();

      // Register package validator
      EValidator.Registry.INSTANCE.put(thePtnetPackage,
         new EValidator.Descriptor() {
            @Override
            public EValidator getEValidator() { return PtnetValidator.INSTANCE; }
         });

      // Mark meta-data to indicate it can't be changed
      thePtnetPackage.freeze();

      // Update the registry and return the package
      EPackage.Registry.INSTANCE.put(PtnetPackage.eNS_URI, thePtnetPackage);
      return thePtnetPackage;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPTMarking() { return ptMarkingEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getPTMarking_Text() { return (EAttribute) ptMarkingEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPTMarking_ContainerPlace() {
      return (EReference) ptMarkingEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPTArcAnnotation() { return ptArcAnnotationEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getPTArcAnnotation_Text() {
      return (EAttribute) ptArcAnnotationEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPTArcAnnotation_ContainerArc() {
      return (EReference) ptArcAnnotationEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getpnml() {
      return pnmlEClass;
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getpnml_Net() {
      return (EReference) pnmlEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getpnml_Xmlns() {
      return (EAttribute) pnmlEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPetriNet() { return petriNetEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getPetriNet_Id() { return (EAttribute) petriNetEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getPetriNet_Type() { return (EAttribute) petriNetEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPetriNet_Page() { return (EReference) petriNetEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPetriNet_Name() { return (EReference) petriNetEClass.getEStructuralFeatures().get(3); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPetriNet_ContainerPetriNetDoc() {
      return (EReference) petriNetEClass.getEStructuralFeatures().get(4);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPetriNet_Toolspecific() { return (EReference) petriNetEClass.getEStructuralFeatures().get(5); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPage() { return pageEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_Arc() { return (EReference) pageEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_ContainerPetriNet() { return (EReference) pageEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_Place() { return (EReference) pageEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_Transition() { return (EReference) pageEClass.getEStructuralFeatures().get(3); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_Page() { return (EReference) pageEClass.getEStructuralFeatures().get(4); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_ContainerPage() { return (EReference) pageEClass.getEStructuralFeatures().get(5); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_ReferencePlace() { return (EReference) pageEClass.getEStructuralFeatures().get(6); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_ReferenceTransition() { return (EReference) pageEClass.getEStructuralFeatures().get(7); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_ReadArc() { return (EReference) pageEClass.getEStructuralFeatures().get(8); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_InhibitorArc() { return (EReference) pageEClass.getEStructuralFeatures().get(9); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPage_Toolspecific() { return (EReference) pageEClass.getEStructuralFeatures().get(10); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPnObject() { return pnObjectEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getPnObject_Id() { return (EAttribute) pnObjectEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPnObject_Name() { return (EReference) pnObjectEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getName_() { return nameEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getName_Text() { return (EAttribute) nameEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getName_ContainerNamePetriNet() { return (EReference) nameEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getName_ContainerNamePnObject() { return (EReference) nameEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getToolInfo() { return toolInfoEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfo_Tool() { return (EAttribute) toolInfoEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfo_Version() { return (EAttribute) toolInfoEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfo_FormattedXMLBuffer() {
      return (EAttribute) toolInfoEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfo_ToolInfoGrammarURI() {
      return (EAttribute) toolInfoEClass.getEStructuralFeatures().get(3);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfo_ContainerLabel() {
      return (EReference) toolInfoEClass.getEStructuralFeatures().get(4);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfo_ToolInfoModel() { return (EReference) toolInfoEClass.getEStructuralFeatures().get(5); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfo_Type() { return (EAttribute) toolInfoEClass.getEStructuralFeatures().get(6); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfo_Arc() { return (EReference) toolInfoEClass.getEStructuralFeatures().get(7); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getLabel() { return labelEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getLabel_Toolspecifics() { return (EReference) labelEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getNodeGraphics() { return nodeGraphicsEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getNodeGraphics_Position() {
      return (EReference) nodeGraphicsEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getNodeGraphics_Dimension() {
      return (EReference) nodeGraphicsEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getNodeGraphics_Fill() { return (EReference) nodeGraphicsEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getNodeGraphics_Line() { return (EReference) nodeGraphicsEClass.getEStructuralFeatures().get(3); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getNodeGraphics_ContainerObject() {
      return (EReference) nodeGraphicsEClass.getEStructuralFeatures().get(4);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getGraphics() { return graphicsEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getCoordinate() { return coordinateEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getCoordinate_X() { return (EAttribute) coordinateEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getCoordinate_Y() { return (EAttribute) coordinateEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPosition() { return positionEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPosition_ContainerArcGraphics() {
      return (EReference) positionEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPosition_ContainerPNodeGraphics() {
      return (EReference) positionEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getOffset() { return offsetEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getOffset_ContainerAnnotationGraphics() {
      return (EReference) offsetEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getDimension() { return dimensionEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getDimension_ContainerDNodeGraphics() {
      return (EReference) dimensionEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getAnnotationGraphics() { return annotationGraphicsEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getAnnotationGraphics_Offset() {
      return (EReference) annotationGraphicsEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getAnnotationGraphics_Fill() {
      return (EReference) annotationGraphicsEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getAnnotationGraphics_Line() {
      return (EReference) annotationGraphicsEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getAnnotationGraphics_Font() {
      return (EReference) annotationGraphicsEClass.getEStructuralFeatures().get(3);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getAnnotationGraphics_ContainerAnnotation() {
      return (EReference) annotationGraphicsEClass.getEStructuralFeatures().get(4);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getFill() { return fillEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFill_Color() { return (EAttribute) fillEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFill_Gradientcolor() { return (EAttribute) fillEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFill_Gradientrotation() { return (EAttribute) fillEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFill_Image() { return (EAttribute) fillEClass.getEStructuralFeatures().get(3); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getFill_ContainerNodeGraphics() { return (EReference) fillEClass.getEStructuralFeatures().get(4); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getFill_ContainerAnnotationGraphics() {
      return (EReference) fillEClass.getEStructuralFeatures().get(5);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getLine() { return lineEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getLine_Color() { return (EAttribute) lineEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getLine_Shape() { return (EAttribute) lineEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getLine_Width() { return (EAttribute) lineEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getLine_ContainerNodeGraphics() { return (EReference) lineEClass.getEStructuralFeatures().get(3); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getLine_ContainerArcGraphics() { return (EReference) lineEClass.getEStructuralFeatures().get(4); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getLine_ContainerAnnotationGraphics() {
      return (EReference) lineEClass.getEStructuralFeatures().get(5);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getLine_Style() { return (EAttribute) lineEClass.getEStructuralFeatures().get(6); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getArcGraphics() { return arcGraphicsEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getArcGraphics_Positions() {
      return (EReference) arcGraphicsEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getArcGraphics_Line() { return (EReference) arcGraphicsEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getArcGraphics_ContainerArc() {
      return (EReference) arcGraphicsEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getArc() { return arcEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getArc_Source() { return (EReference) arcEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getArc_Target() { return (EReference) arcEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getArc_ContainerPage() { return (EReference) arcEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getArc_Toolspecific() { return (EReference) arcEClass.getEStructuralFeatures().get(3); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getNode() { return nodeEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getNode_InArcs() { return (EReference) nodeEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getNode_OutArcs() { return (EReference) nodeEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getFont() { return fontEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFont_Align() { return (EAttribute) fontEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFont_Decoration() { return (EAttribute) fontEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFont_Family() { return (EAttribute) fontEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFont_Rotation() { return (EAttribute) fontEClass.getEStructuralFeatures().get(3); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFont_Size() { return (EAttribute) fontEClass.getEStructuralFeatures().get(4); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFont_Style() { return (EAttribute) fontEClass.getEStructuralFeatures().get(5); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getFont_Weight() { return (EAttribute) fontEClass.getEStructuralFeatures().get(6); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getFont_ContainerAnnotationGraphics() {
      return (EReference) fontEClass.getEStructuralFeatures().get(7);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPlaceNode() { return placeNodeEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPlaceNode_ReferencingPlaces() {
      return (EReference) placeNodeEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPlaceNode_InhibitorArcs() {
      return (EReference) placeNodeEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPlaceNode_ReadArcs() { return (EReference) placeNodeEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getTransitionNode() { return transitionNodeEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getTransitionNode_ReferencingTransitions() {
      return (EReference) transitionNodeEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getTransitionNode_InhibitorArcs() {
      return (EReference) transitionNodeEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getTransitionNode_ReadArcs() {
      return (EReference) transitionNodeEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPlace() { return placeEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPlace_InitialMarking() { return (EReference) placeEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPlace_ContainerPage() { return (EReference) placeEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPlace_Toolspecific() { return (EReference) placeEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getRefTransition() { return refTransitionEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getRefTransition_Ref() { return (EReference) refTransitionEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getRefTransition_ContainerPage() {
      return (EReference) refTransitionEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getRefTransition_Toolspecific() {
      return (EReference) refTransitionEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getTransition() { return transitionEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getTransition_ContainerPage() {
      return (EReference) transitionEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getTransition_Toolspecific() {
      return (EReference) transitionEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getRefPlace() { return refPlaceEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getRefPlace_Ref() { return (EReference) refPlaceEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getRefPlace_ContainerPage() { return (EReference) refPlaceEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getRefPlace_Toolspecific() { return (EReference) refPlaceEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getAttribute() { return attributeEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getAnnotation() { return annotationEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getAnnotation_Annotationgraphics() {
      return (EReference) annotationEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getAnyObject() { return anyObjectEClass; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getAnyObject_ContainerToolInfo() {
      return (EReference) anyObjectEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getEdge() { return edgeEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getEdge_Arcgraphics() { return (EReference) edgeEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getEdge_Inscription() { return (EReference) edgeEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getInhibitorArc() { return inhibitorArcEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getInhibitorArc_Page() { return (EReference) inhibitorArcEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getInhibitorArc_Source() {
      return (EReference) inhibitorArcEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getInhibitorArc_Target() {
      return (EReference) inhibitorArcEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getReadArc() { return readArcEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getReadArc_ContainerPage() { return (EReference) readArcEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getReadArc_Source() { return (EReference) readArcEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getReadArc_Target() { return (EReference) readArcEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPositionableObject() { return positionableObjectEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPositionableObject_Nodegraphics() {
      return (EReference) positionableObjectEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getToolInfoPlace() { return toolInfoPlaceEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoPlace_BalloonMarking() {
      return (EReference) toolInfoPlaceEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoPlace_Place() {
      return (EReference) toolInfoPlaceEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getToolInfoTransition() { return toolInfoTransitionEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfoTransition_Inputsignalclause() {
      return (EAttribute) toolInfoTransitionEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfoTransition_TopicName() {
      return (EAttribute) toolInfoTransitionEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfoTransition_ServiceName() {
      return (EAttribute) toolInfoTransitionEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfoTransition_ServerInput() {
      return (EAttribute) toolInfoTransitionEClass.getEStructuralFeatures().get(3);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfoTransition_ServerOutput() {
      return (EAttribute) toolInfoTransitionEClass.getEStructuralFeatures().get(4);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfoTransition_ServerCapacity() {
      return (EAttribute) toolInfoTransitionEClass.getEStructuralFeatures().get(5);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoTransition_Channels() {
      return (EReference) toolInfoTransitionEClass.getEStructuralFeatures().get(6);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoTransition_Publishers() {
      return (EReference) toolInfoTransitionEClass.getEStructuralFeatures().get(7);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoTransition_Subscribers() {
      return (EReference) toolInfoTransitionEClass.getEStructuralFeatures().get(8);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoTransition_Transition() {
      return (EReference) toolInfoTransitionEClass.getEStructuralFeatures().get(9);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getToolInfoPage() { return toolInfoPageEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfoPage_ServiceName() {
      return (EAttribute) toolInfoPageEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoPage_Page() { return (EReference) toolInfoPageEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getToolInfoNet() { return toolInfoNetEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoNet_Inputsignals() {
      return (EReference) toolInfoNetEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoNet_Petrinet() {
      return (EReference) toolInfoNetEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getTokens() { return tokensEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getTokens_BalloonMarking() { return (EReference) tokensEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getTokens_Token() { return (EAttribute) tokensEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getBalloonMarking() { return balloonMarkingEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getBalloonMarking_ToolInfoPlace() {
      return (EReference) balloonMarkingEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getBalloonMarking_Tokens() {
      return (EReference) balloonMarkingEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getInputSignals() { return inputSignalsEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getInputSignals_ToolInfoNet() {
      return (EReference) inputSignalsEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getInputSignals_Inputsignal() {
      return (EReference) inputSignalsEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getInputSignal() { return inputSignalEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getInputSignal_InputsignalsContainer() {
      return (EReference) inputSignalEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getInputSignal_InputsignalID() {
      return (EAttribute) inputSignalEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getInputSignal_Initialvalue() {
      return (EAttribute) inputSignalEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getChannels() { return channelsEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getChannels_ToolInfoTransition() {
      return (EReference) channelsEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getChannels_Channel() { return (EReference) channelsEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getChannel() { return channelEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getChannel_Cid() { return (EAttribute) channelEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getChannel_Request() { return (EAttribute) channelEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getChannel_Response() { return (EAttribute) channelEClass.getEStructuralFeatures().get(2); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getChannel_ChannelsContainer() {
      return (EReference) channelEClass.getEStructuralFeatures().get(3);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPublishers() { return publishersEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPublishers_ToolInfoTransition() {
      return (EReference) publishersEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPublishers_Publisher() { return (EReference) publishersEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getPublisher() { return publisherEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getPublisher_Id() { return (EAttribute) publisherEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getPublisher_Limit() { return (EAttribute) publisherEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getPublisher_PublishersContainer() {
      return (EReference) publisherEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getSubscribers() { return subscribersEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getSubscribers_ToolInfoTransition() {
      return (EReference) subscribersEClass.getEStructuralFeatures().get(0);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getSubscribers_Subscriber() {
      return (EReference) subscribersEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getSubscriber() { return subscriberEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getSubscriber_Id() { return (EAttribute) subscriberEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getSubscriber_Limit() { return (EAttribute) subscriberEClass.getEStructuralFeatures().get(1); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getSubscriber_SubscribersContainer() {
      return (EReference) subscriberEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EClass getToolInfoNode() { return toolInfoNodeEClass; }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfoNode_Node() { return (EAttribute) toolInfoNodeEClass.getEStructuralFeatures().get(0); }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EAttribute getToolInfoNode_Subnet() {
      return (EAttribute) toolInfoNodeEClass.getEStructuralFeatures().get(1);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoNode_RefTransition() {
      return (EReference) toolInfoNodeEClass.getEStructuralFeatures().get(2);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EReference getToolInfoNode_RefPlace() {
      return (EReference) toolInfoNodeEClass.getEStructuralFeatures().get(3);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getPNType() { return pnTypeEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getCSS2Color() { return css2ColorEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getGradient() { return gradientEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getLineShape() { return lineShapeEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getFontAlign() { return fontAlignEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getFontDecoration() { return fontDecorationEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getCSS2FontFamily() { return css2FontFamilyEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getCSS2FontSize() { return css2FontSizeEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getCSS2FontStyle() { return css2FontStyleEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getCSS2FontWeight() { return css2FontWeightEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EEnum getLineStyle() { return lineStyleEEnum; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EDataType getPositiveInteger() { return positiveIntegerEDataType; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EDataType getNatural() { return naturalEDataType; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EDataType getURI() { return uriEDataType; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EDataType getLongString() { return longStringEDataType; }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public PtnetFactory getPtnetFactory() { return (PtnetFactory) getEFactoryInstance(); }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private boolean isCreated = false;

   /**
    * Creates the meta-model objects for the package.  This method is
    * guarded to have no affect on any invocation but its first.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void createPackageContents() {
      if (isCreated)
         return;
      isCreated = true;

      // Create classes and their features
      ptMarkingEClass = createEClass(PT_MARKING);
      createEAttribute(ptMarkingEClass, PT_MARKING__TEXT);
      createEReference(ptMarkingEClass, PT_MARKING__CONTAINER_PLACE);

      ptArcAnnotationEClass = createEClass(PT_ARC_ANNOTATION);
      createEAttribute(ptArcAnnotationEClass, PT_ARC_ANNOTATION__TEXT);
      createEReference(ptArcAnnotationEClass, PT_ARC_ANNOTATION__CONTAINER_ARC);

      pnmlEClass = createEClass(PNML);
      createEReference(pnmlEClass, PNML__NET);
      createEAttribute(pnmlEClass, PNML__XMLNS);

      petriNetEClass = createEClass(PETRI_NET);
      createEAttribute(petriNetEClass, PETRI_NET__ID);
      createEAttribute(petriNetEClass, PETRI_NET__TYPE);
      createEReference(petriNetEClass, PETRI_NET__PAGE);
      createEReference(petriNetEClass, PETRI_NET__NAME);
      createEReference(petriNetEClass, PETRI_NET__CONTAINER_PETRI_NET_DOC);
      createEReference(petriNetEClass, PETRI_NET__TOOLSPECIFIC);

      pageEClass = createEClass(PAGE);
      createEReference(pageEClass, PAGE__ARC);
      createEReference(pageEClass, PAGE__CONTAINER_PETRI_NET);
      createEReference(pageEClass, PAGE__PLACE);
      createEReference(pageEClass, PAGE__TRANSITION);
      createEReference(pageEClass, PAGE__PAGE);
      createEReference(pageEClass, PAGE__CONTAINER_PAGE);
      createEReference(pageEClass, PAGE__REFERENCE_PLACE);
      createEReference(pageEClass, PAGE__REFERENCE_TRANSITION);
      createEReference(pageEClass, PAGE__READ_ARC);
      createEReference(pageEClass, PAGE__INHIBITOR_ARC);
      createEReference(pageEClass, PAGE__TOOLSPECIFIC);

      pnObjectEClass = createEClass(PN_OBJECT);
      createEAttribute(pnObjectEClass, PN_OBJECT__ID);
      createEReference(pnObjectEClass, PN_OBJECT__NAME);

      nameEClass = createEClass(NAME);
      createEAttribute(nameEClass, NAME__TEXT);
      createEReference(nameEClass, NAME__CONTAINER_NAME_PETRI_NET);
      createEReference(nameEClass, NAME__CONTAINER_NAME_PN_OBJECT);

      toolInfoEClass = createEClass(TOOL_INFO);
      createEAttribute(toolInfoEClass, TOOL_INFO__TOOL);
      createEAttribute(toolInfoEClass, TOOL_INFO__VERSION);
      createEAttribute(toolInfoEClass, TOOL_INFO__FORMATTED_XML_BUFFER);
      createEAttribute(toolInfoEClass, TOOL_INFO__TOOL_INFO_GRAMMAR_URI);
      createEReference(toolInfoEClass, TOOL_INFO__CONTAINER_LABEL);
      createEReference(toolInfoEClass, TOOL_INFO__TOOL_INFO_MODEL);
      createEAttribute(toolInfoEClass, TOOL_INFO__TYPE);
      createEReference(toolInfoEClass, TOOL_INFO__ARC);

      labelEClass = createEClass(LABEL);
      createEReference(labelEClass, LABEL__TOOLSPECIFICS);

      nodeGraphicsEClass = createEClass(NODE_GRAPHICS);
      createEReference(nodeGraphicsEClass, NODE_GRAPHICS__POSITION);
      createEReference(nodeGraphicsEClass, NODE_GRAPHICS__DIMENSION);
      createEReference(nodeGraphicsEClass, NODE_GRAPHICS__FILL);
      createEReference(nodeGraphicsEClass, NODE_GRAPHICS__LINE);
      createEReference(nodeGraphicsEClass, NODE_GRAPHICS__CONTAINER_OBJECT);

      graphicsEClass = createEClass(GRAPHICS);

      coordinateEClass = createEClass(COORDINATE);
      createEAttribute(coordinateEClass, COORDINATE__X);
      createEAttribute(coordinateEClass, COORDINATE__Y);

      positionEClass = createEClass(POSITION);
      createEReference(positionEClass, POSITION__CONTAINER_ARC_GRAPHICS);
      createEReference(positionEClass, POSITION__CONTAINER_PNODE_GRAPHICS);

      offsetEClass = createEClass(OFFSET);
      createEReference(offsetEClass, OFFSET__CONTAINER_ANNOTATION_GRAPHICS);

      dimensionEClass = createEClass(DIMENSION);
      createEReference(dimensionEClass, DIMENSION__CONTAINER_DNODE_GRAPHICS);

      annotationGraphicsEClass = createEClass(ANNOTATION_GRAPHICS);
      createEReference(annotationGraphicsEClass, ANNOTATION_GRAPHICS__OFFSET);
      createEReference(annotationGraphicsEClass, ANNOTATION_GRAPHICS__FILL);
      createEReference(annotationGraphicsEClass, ANNOTATION_GRAPHICS__LINE);
      createEReference(annotationGraphicsEClass, ANNOTATION_GRAPHICS__FONT);
      createEReference(annotationGraphicsEClass, ANNOTATION_GRAPHICS__CONTAINER_ANNOTATION);

      fillEClass = createEClass(FILL);
      createEAttribute(fillEClass, FILL__COLOR);
      createEAttribute(fillEClass, FILL__GRADIENTCOLOR);
      createEAttribute(fillEClass, FILL__GRADIENTROTATION);
      createEAttribute(fillEClass, FILL__IMAGE);
      createEReference(fillEClass, FILL__CONTAINER_NODE_GRAPHICS);
      createEReference(fillEClass, FILL__CONTAINER_ANNOTATION_GRAPHICS);

      lineEClass = createEClass(LINE);
      createEAttribute(lineEClass, LINE__COLOR);
      createEAttribute(lineEClass, LINE__SHAPE);
      createEAttribute(lineEClass, LINE__WIDTH);
      createEReference(lineEClass, LINE__CONTAINER_NODE_GRAPHICS);
      createEReference(lineEClass, LINE__CONTAINER_ARC_GRAPHICS);
      createEReference(lineEClass, LINE__CONTAINER_ANNOTATION_GRAPHICS);
      createEAttribute(lineEClass, LINE__STYLE);

      arcGraphicsEClass = createEClass(ARC_GRAPHICS);
      createEReference(arcGraphicsEClass, ARC_GRAPHICS__POSITIONS);
      createEReference(arcGraphicsEClass, ARC_GRAPHICS__LINE);
      createEReference(arcGraphicsEClass, ARC_GRAPHICS__CONTAINER_ARC);

      arcEClass = createEClass(ARC);
      createEReference(arcEClass, ARC__SOURCE);
      createEReference(arcEClass, ARC__TARGET);
      createEReference(arcEClass, ARC__CONTAINER_PAGE);
      createEReference(arcEClass, ARC__TOOLSPECIFIC);

      nodeEClass = createEClass(NODE);
      createEReference(nodeEClass, NODE__IN_ARCS);
      createEReference(nodeEClass, NODE__OUT_ARCS);

      fontEClass = createEClass(FONT);
      createEAttribute(fontEClass, FONT__ALIGN);
      createEAttribute(fontEClass, FONT__DECORATION);
      createEAttribute(fontEClass, FONT__FAMILY);
      createEAttribute(fontEClass, FONT__ROTATION);
      createEAttribute(fontEClass, FONT__SIZE);
      createEAttribute(fontEClass, FONT__STYLE);
      createEAttribute(fontEClass, FONT__WEIGHT);
      createEReference(fontEClass, FONT__CONTAINER_ANNOTATION_GRAPHICS);

      placeNodeEClass = createEClass(PLACE_NODE);
      createEReference(placeNodeEClass, PLACE_NODE__REFERENCING_PLACES);
      createEReference(placeNodeEClass, PLACE_NODE__INHIBITOR_ARCS);
      createEReference(placeNodeEClass, PLACE_NODE__READ_ARCS);

      transitionNodeEClass = createEClass(TRANSITION_NODE);
      createEReference(transitionNodeEClass, TRANSITION_NODE__REFERENCING_TRANSITIONS);
      createEReference(transitionNodeEClass, TRANSITION_NODE__INHIBITOR_ARCS);
      createEReference(transitionNodeEClass, TRANSITION_NODE__READ_ARCS);

      placeEClass = createEClass(PLACE);
      createEReference(placeEClass, PLACE__INITIAL_MARKING);
      createEReference(placeEClass, PLACE__CONTAINER_PAGE);
      createEReference(placeEClass, PLACE__TOOLSPECIFIC);

      refTransitionEClass = createEClass(REF_TRANSITION);
      createEReference(refTransitionEClass, REF_TRANSITION__REF);
      createEReference(refTransitionEClass, REF_TRANSITION__CONTAINER_PAGE);
      createEReference(refTransitionEClass, REF_TRANSITION__TOOLSPECIFIC);

      transitionEClass = createEClass(TRANSITION);
      createEReference(transitionEClass, TRANSITION__CONTAINER_PAGE);
      createEReference(transitionEClass, TRANSITION__TOOLSPECIFIC);

      refPlaceEClass = createEClass(REF_PLACE);
      createEReference(refPlaceEClass, REF_PLACE__REF);
      createEReference(refPlaceEClass, REF_PLACE__CONTAINER_PAGE);
      createEReference(refPlaceEClass, REF_PLACE__TOOLSPECIFIC);

      attributeEClass = createEClass(ATTRIBUTE);

      annotationEClass = createEClass(ANNOTATION);
      createEReference(annotationEClass, ANNOTATION__ANNOTATIONGRAPHICS);

      anyObjectEClass = createEClass(ANY_OBJECT);
      createEReference(anyObjectEClass, ANY_OBJECT__CONTAINER_TOOL_INFO);

      edgeEClass = createEClass(EDGE);
      createEReference(edgeEClass, EDGE__ARCGRAPHICS);
      createEReference(edgeEClass, EDGE__INSCRIPTION);

      inhibitorArcEClass = createEClass(INHIBITOR_ARC);
      createEReference(inhibitorArcEClass, INHIBITOR_ARC__PAGE);
      createEReference(inhibitorArcEClass, INHIBITOR_ARC__SOURCE);
      createEReference(inhibitorArcEClass, INHIBITOR_ARC__TARGET);

      readArcEClass = createEClass(READ_ARC);
      createEReference(readArcEClass, READ_ARC__CONTAINER_PAGE);
      createEReference(readArcEClass, READ_ARC__SOURCE);
      createEReference(readArcEClass, READ_ARC__TARGET);

      positionableObjectEClass = createEClass(POSITIONABLE_OBJECT);
      createEReference(positionableObjectEClass, POSITIONABLE_OBJECT__NODEGRAPHICS);

      toolInfoPlaceEClass = createEClass(TOOL_INFO_PLACE);
      createEReference(toolInfoPlaceEClass, TOOL_INFO_PLACE__BALLOON_MARKING);
      createEReference(toolInfoPlaceEClass, TOOL_INFO_PLACE__PLACE);

      toolInfoTransitionEClass = createEClass(TOOL_INFO_TRANSITION);
      createEAttribute(toolInfoTransitionEClass, TOOL_INFO_TRANSITION__INPUTSIGNALCLAUSE);
      createEAttribute(toolInfoTransitionEClass, TOOL_INFO_TRANSITION__TOPIC_NAME);
      createEAttribute(toolInfoTransitionEClass, TOOL_INFO_TRANSITION__SERVICE_NAME);
      createEAttribute(toolInfoTransitionEClass, TOOL_INFO_TRANSITION__SERVER_INPUT);
      createEAttribute(toolInfoTransitionEClass, TOOL_INFO_TRANSITION__SERVER_OUTPUT);
      createEAttribute(toolInfoTransitionEClass, TOOL_INFO_TRANSITION__SERVER_CAPACITY);
      createEReference(toolInfoTransitionEClass, TOOL_INFO_TRANSITION__CHANNELS);
      createEReference(toolInfoTransitionEClass, TOOL_INFO_TRANSITION__PUBLISHERS);
      createEReference(toolInfoTransitionEClass, TOOL_INFO_TRANSITION__SUBSCRIBERS);
      createEReference(toolInfoTransitionEClass, TOOL_INFO_TRANSITION__TRANSITION);

      toolInfoPageEClass = createEClass(TOOL_INFO_PAGE);
      createEAttribute(toolInfoPageEClass, TOOL_INFO_PAGE__SERVICE_NAME);
      createEReference(toolInfoPageEClass, TOOL_INFO_PAGE__PAGE);

      toolInfoNetEClass = createEClass(TOOL_INFO_NET);
      createEReference(toolInfoNetEClass, TOOL_INFO_NET__INPUTSIGNALS);
      createEReference(toolInfoNetEClass, TOOL_INFO_NET__PETRINET);

      tokensEClass = createEClass(TOKENS);
      createEReference(tokensEClass, TOKENS__BALLOON_MARKING);
      createEAttribute(tokensEClass, TOKENS__TOKEN);

      balloonMarkingEClass = createEClass(BALLOON_MARKING);
      createEReference(balloonMarkingEClass, BALLOON_MARKING__TOOL_INFO_PLACE);
      createEReference(balloonMarkingEClass, BALLOON_MARKING__TOKENS);

      inputSignalsEClass = createEClass(INPUT_SIGNALS);
      createEReference(inputSignalsEClass, INPUT_SIGNALS__TOOL_INFO_NET);
      createEReference(inputSignalsEClass, INPUT_SIGNALS__INPUTSIGNAL);

      inputSignalEClass = createEClass(INPUT_SIGNAL);
      createEReference(inputSignalEClass, INPUT_SIGNAL__INPUTSIGNALS_CONTAINER);
      createEAttribute(inputSignalEClass, INPUT_SIGNAL__INPUTSIGNAL_ID);
      createEAttribute(inputSignalEClass, INPUT_SIGNAL__INITIALVALUE);

      channelsEClass = createEClass(CHANNELS);
      createEReference(channelsEClass, CHANNELS__TOOL_INFO_TRANSITION);
      createEReference(channelsEClass, CHANNELS__CHANNEL);

      channelEClass = createEClass(CHANNEL);
      createEAttribute(channelEClass, CHANNEL__CID);
      createEAttribute(channelEClass, CHANNEL__REQUEST);
      createEAttribute(channelEClass, CHANNEL__RESPONSE);
      createEReference(channelEClass, CHANNEL__CHANNELS_CONTAINER);

      publishersEClass = createEClass(PUBLISHERS);
      createEReference(publishersEClass, PUBLISHERS__TOOL_INFO_TRANSITION);
      createEReference(publishersEClass, PUBLISHERS__PUBLISHER);

      publisherEClass = createEClass(PUBLISHER);
      createEAttribute(publisherEClass, PUBLISHER__ID);
      createEAttribute(publisherEClass, PUBLISHER__LIMIT);
      createEReference(publisherEClass, PUBLISHER__PUBLISHERS_CONTAINER);

      subscribersEClass = createEClass(SUBSCRIBERS);
      createEReference(subscribersEClass, SUBSCRIBERS__TOOL_INFO_TRANSITION);
      createEReference(subscribersEClass, SUBSCRIBERS__SUBSCRIBER);

      subscriberEClass = createEClass(SUBSCRIBER);
      createEAttribute(subscriberEClass, SUBSCRIBER__ID);
      createEAttribute(subscriberEClass, SUBSCRIBER__LIMIT);
      createEReference(subscriberEClass, SUBSCRIBER__SUBSCRIBERS_CONTAINER);

      toolInfoNodeEClass = createEClass(TOOL_INFO_NODE);
      createEAttribute(toolInfoNodeEClass, TOOL_INFO_NODE__NODE);
      createEAttribute(toolInfoNodeEClass, TOOL_INFO_NODE__SUBNET);
      createEReference(toolInfoNodeEClass, TOOL_INFO_NODE__REF_TRANSITION);
      createEReference(toolInfoNodeEClass, TOOL_INFO_NODE__REF_PLACE);

      // Create enums
      pnTypeEEnum = createEEnum(PN_TYPE);
      css2ColorEEnum = createEEnum(CSS2_COLOR);
      gradientEEnum = createEEnum(GRADIENT);
      lineShapeEEnum = createEEnum(LINE_SHAPE);
      fontAlignEEnum = createEEnum(FONT_ALIGN);
      fontDecorationEEnum = createEEnum(FONT_DECORATION);
      css2FontFamilyEEnum = createEEnum(CSS2_FONT_FAMILY);
      css2FontSizeEEnum = createEEnum(CSS2_FONT_SIZE);
      css2FontStyleEEnum = createEEnum(CSS2_FONT_STYLE);
      css2FontWeightEEnum = createEEnum(CSS2_FONT_WEIGHT);
      lineStyleEEnum = createEEnum(LINE_STYLE);

      // Create data types
      positiveIntegerEDataType = createEDataType(POSITIVE_INTEGER);
      naturalEDataType = createEDataType(NATURAL);
      uriEDataType = createEDataType(URI);
      longStringEDataType = createEDataType(LONG_STRING);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private boolean isInitialized = false;

   /**
    * Complete the initialization of the package and its meta-model.  This
    * method is guarded to have no affect on any invocation but its first.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void initializePackageContents() {
      if (isInitialized)
         return;
      isInitialized = true;

      // Initialize package
      setName(eNAME);
      setNsPrefix(eNS_PREFIX);
      setNsURI(eNS_URI);

      // Create type parameters

      // Set bounds for type parameters

      // Add supertypes to classes
      ptMarkingEClass.getESuperTypes().add(this.getAnnotation());
      ptArcAnnotationEClass.getESuperTypes().add(this.getAnnotation());
      pageEClass.getESuperTypes().add(this.getPositionableObject());
      nameEClass.getESuperTypes().add(this.getAnnotation());
      nodeGraphicsEClass.getESuperTypes().add(this.getGraphics());
      positionEClass.getESuperTypes().add(this.getCoordinate());
      offsetEClass.getESuperTypes().add(this.getCoordinate());
      dimensionEClass.getESuperTypes().add(this.getCoordinate());
      annotationGraphicsEClass.getESuperTypes().add(this.getGraphics());
      arcGraphicsEClass.getESuperTypes().add(this.getGraphics());
      arcEClass.getESuperTypes().add(this.getEdge());
      nodeEClass.getESuperTypes().add(this.getPositionableObject());
      placeNodeEClass.getESuperTypes().add(this.getNode());
      transitionNodeEClass.getESuperTypes().add(this.getNode());
      placeEClass.getESuperTypes().add(this.getPlaceNode());
      refTransitionEClass.getESuperTypes().add(this.getTransitionNode());
      transitionEClass.getESuperTypes().add(this.getTransitionNode());
      refPlaceEClass.getESuperTypes().add(this.getPlaceNode());
      attributeEClass.getESuperTypes().add(this.getLabel());
      annotationEClass.getESuperTypes().add(this.getLabel());
      edgeEClass.getESuperTypes().add(this.getPnObject());
      inhibitorArcEClass.getESuperTypes().add(this.getEdge());
      readArcEClass.getESuperTypes().add(this.getEdge());
      positionableObjectEClass.getESuperTypes().add(this.getPnObject());
      toolInfoPlaceEClass.getESuperTypes().add(this.getToolInfoNode());
      toolInfoTransitionEClass.getESuperTypes().add(this.getToolInfoNode());
      toolInfoPageEClass.getESuperTypes().add(this.getToolInfo());
      toolInfoNetEClass.getESuperTypes().add(this.getToolInfo());
      toolInfoNodeEClass.getESuperTypes().add(this.getToolInfo());

      // Initialize classes, features, and operations; add parameters
      initEClass(ptMarkingEClass, PTMarking.class, "PTMarking", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getPTMarking_Text(), this.getNatural(), "text", null, 1, 1, PTMarking.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getPTMarking_ContainerPlace(), this.getPlace(), this.getPlace_InitialMarking(), "containerPlace",
         null, 0, 1, PTMarking.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(ptArcAnnotationEClass, PTArcAnnotation.class, "PTArcAnnotation", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getPTArcAnnotation_Text(), this.getPositiveInteger(), "text", null, 1, 1, PTArcAnnotation.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getPTArcAnnotation_ContainerArc(), this.getEdge(), this.getEdge_Inscription(), "containerArc",
         null, 0, 1, PTArcAnnotation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(pnmlEClass, pnml.class, "pnml", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getpnml_Net(), this.getPetriNet(), this.getPetriNet_ContainerPetriNetDoc(), "net", null, 1, -1,
         pnml.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getpnml_Xmlns(), ecorePackage.getEString(), "xmlns",
         "http://www.pnml.org/version-2009/grammar/pnml", 0, 1, pnml.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE,
         !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(petriNetEClass, PetriNet.class, "PetriNet", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getPetriNet_Id(), ecorePackage.getEString(), "id", "", 1, 1, PetriNet.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getPetriNet_Type(), this.getPNType(), "type", "", 1, 1, PetriNet.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPetriNet_Page(), this.getPage(), this.getPage_ContainerPetriNet(), "page", null, 1, -1,
         PetriNet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPetriNet_Name(), this.getName_(), this.getName_ContainerNamePetriNet(), "name", null, 0, 1,
         PetriNet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPetriNet_ContainerPetriNetDoc(), this.getpnml(), this.getpnml_Net(), "containerPetriNetDoc",
         null, 0, 1, PetriNet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPetriNet_Toolspecific(), this.getToolInfoNet(), this.getToolInfoNet_Petrinet(), "toolspecific",
         null, 0, -1, PetriNet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(pageEClass, Page.class, "Page", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getPage_Arc(), this.getArc(), this.getArc_ContainerPage(), "arc", null, 0, -1, Page.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, !IS_ORDERED);
      initEReference(getPage_ContainerPetriNet(), this.getPetriNet(), this.getPetriNet_Page(), "containerPetriNet",
         null, 0, 1, Page.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPage_Place(), this.getPlace(), this.getPlace_ContainerPage(), "place", null, 0, -1, Page.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, !IS_ORDERED);
      initEReference(getPage_Transition(), this.getTransition(), this.getTransition_ContainerPage(), "transition", null,
         0, -1, Page.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPage_Page(), this.getPage(), this.getPage_ContainerPage(), "page", null, 0, -1, Page.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, !IS_ORDERED);
      initEReference(getPage_ContainerPage(), this.getPage(), this.getPage_Page(), "containerPage", null, 0, 1,
         Page.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPage_ReferencePlace(), this.getRefPlace(), this.getRefPlace_ContainerPage(), "referencePlace",
         null, 0, -1, Page.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPage_ReferenceTransition(), this.getRefTransition(), this.getRefTransition_ContainerPage(),
         "referenceTransition", null, 0, -1, Page.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPage_ReadArc(), this.getReadArc(), this.getReadArc_ContainerPage(), "readArc", null, 0, -1,
         Page.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPage_InhibitorArc(), this.getInhibitorArc(), this.getInhibitorArc_Page(), "inhibitorArc", null,
         0, -1, Page.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPage_Toolspecific(), this.getToolInfoPage(), this.getToolInfoPage_Page(), "toolspecific", null,
         0, -1, Page.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(pnObjectEClass, PnObject.class, "PnObject", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getPnObject_Id(), ecorePackage.getEString(), "id", null, 1, 1, PnObject.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPnObject_Name(), this.getName_(), this.getName_ContainerNamePnObject(), "name", null, 0, 1,
         PnObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass(nameEClass, Name.class, "Name", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getName_Text(), ecorePackage.getEString(), "text", null, 1, 1, Name.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getName_ContainerNamePetriNet(), this.getPetriNet(), this.getPetriNet_Name(),
         "containerNamePetriNet", null, 0, 1, Name.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getName_ContainerNamePnObject(), this.getPnObject(), this.getPnObject_Name(),
         "containerNamePnObject", null, 0, 1, Name.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(toolInfoEClass, ToolInfo.class, "ToolInfo", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getToolInfo_Tool(), ecorePackage.getEString(), "tool", null, 1, 1, ToolInfo.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getToolInfo_Version(), ecorePackage.getEString(), "version", null, 1, 1, ToolInfo.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getToolInfo_FormattedXMLBuffer(), this.getLongString(), "formattedXMLBuffer", null, 0, 1,
         ToolInfo.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
         !IS_ORDERED);
      initEAttribute(getToolInfo_ToolInfoGrammarURI(), this.getURI(), "toolInfoGrammarURI", null, 0, 1, ToolInfo.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getToolInfo_ContainerLabel(), this.getLabel(), this.getLabel_Toolspecifics(), "containerLabel",
         null, 0, 1, ToolInfo.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getToolInfo_ToolInfoModel(), this.getAnyObject(), this.getAnyObject_ContainerToolInfo(),
         "toolInfoModel", null, 0, 1, ToolInfo.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEAttribute(getToolInfo_Type(), ecorePackage.getEString(), "type", null, 0, 1, ToolInfo.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getToolInfo_Arc(), this.getArc(), this.getArc_Toolspecific(), "arc", null, 0, 1, ToolInfo.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, IS_ORDERED);

      initEClass(labelEClass, Label.class, "Label", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getLabel_Toolspecifics(), this.getToolInfo(), this.getToolInfo_ContainerLabel(), "toolspecifics",
         null, 0, -1, Label.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass(nodeGraphicsEClass, NodeGraphics.class, "NodeGraphics", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getNodeGraphics_Position(), this.getPosition(), this.getPosition_ContainerPNodeGraphics(),
         "position", null, 0, 1, NodeGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getNodeGraphics_Dimension(), this.getDimension(), this.getDimension_ContainerDNodeGraphics(),
         "dimension", null, 0, 1, NodeGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getNodeGraphics_Fill(), this.getFill(), this.getFill_ContainerNodeGraphics(), "fill", null, 0, 1,
         NodeGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getNodeGraphics_Line(), this.getLine(), this.getLine_ContainerNodeGraphics(), "line", null, 0, 1,
         NodeGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getNodeGraphics_ContainerObject(), this.getPositionableObject(),
         this.getPositionableObject_Nodegraphics(), "containerObject", null, 0, 1, NodeGraphics.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         !IS_ORDERED);

      initEClass(graphicsEClass, Graphics.class, "Graphics", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass(coordinateEClass, Coordinate.class, "Coordinate", IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getCoordinate_X(), ecorePackage.getEIntegerObject(), "x", null, 1, 1, Coordinate.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getCoordinate_Y(), ecorePackage.getEIntegerObject(), "y", null, 1, 1, Coordinate.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass(positionEClass, Position.class, "Position", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getPosition_ContainerArcGraphics(), this.getArcGraphics(), this.getArcGraphics_Positions(),
         "containerArcGraphics", null, 0, 1, Position.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPosition_ContainerPNodeGraphics(), this.getNodeGraphics(), this.getNodeGraphics_Position(),
         "containerPNodeGraphics", null, 0, 1, Position.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
         !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(offsetEClass, Offset.class, "Offset", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getOffset_ContainerAnnotationGraphics(), this.getAnnotationGraphics(),
         this.getAnnotationGraphics_Offset(), "containerAnnotationGraphics", null, 0, 1, Offset.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         !IS_ORDERED);

      initEClass(dimensionEClass, Dimension.class, "Dimension", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getDimension_ContainerDNodeGraphics(), this.getNodeGraphics(), this.getNodeGraphics_Dimension(),
         "containerDNodeGraphics", null, 0, 1, Dimension.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
         !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass(annotationGraphicsEClass, AnnotationGraphics.class, "AnnotationGraphics", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getAnnotationGraphics_Offset(), this.getOffset(), this.getOffset_ContainerAnnotationGraphics(),
         "offset", null, 0, 1, AnnotationGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getAnnotationGraphics_Fill(), this.getFill(), this.getFill_ContainerAnnotationGraphics(), "fill",
         null, 0, 1, AnnotationGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getAnnotationGraphics_Line(), this.getLine(), this.getLine_ContainerAnnotationGraphics(), "line",
         null, 0, 1, AnnotationGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getAnnotationGraphics_Font(), this.getFont(), this.getFont_ContainerAnnotationGraphics(), "font",
         null, 0, 1, AnnotationGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getAnnotationGraphics_ContainerAnnotation(), this.getAnnotation(),
         this.getAnnotation_Annotationgraphics(), "containerAnnotation", null, 0, 1, AnnotationGraphics.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, IS_ORDERED);

      initEClass(fillEClass, Fill.class, "Fill", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getFill_Color(), this.getCSS2Color(), "color", "BLACK", 0, 1, Fill.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getFill_Gradientcolor(), this.getCSS2Color(), "gradientcolor", "BLACK", 0, 1, Fill.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getFill_Gradientrotation(), this.getGradient(), "gradientrotation", null, 0, 1, Fill.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getFill_Image(), this.getURI(), "image", null, 0, 1, Fill.class, !IS_TRANSIENT, !IS_VOLATILE,
         IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getFill_ContainerNodeGraphics(), this.getNodeGraphics(), this.getNodeGraphics_Fill(),
         "containerNodeGraphics", null, 0, 1, Fill.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getFill_ContainerAnnotationGraphics(), this.getAnnotationGraphics(),
         this.getAnnotationGraphics_Fill(), "containerAnnotationGraphics", null, 0, 1, Fill.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         !IS_ORDERED);

      initEClass(lineEClass, Line.class, "Line", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getLine_Color(), this.getCSS2Color(), "color", "BLACK", 0, 1, Line.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getLine_Shape(), this.getLineShape(), "shape", "LINE", 0, 1, Line.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getLine_Width(), ecorePackage.getEIntegerObject(), "width", null, 0, 1, Line.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getLine_ContainerNodeGraphics(), this.getNodeGraphics(), this.getNodeGraphics_Line(),
         "containerNodeGraphics", null, 0, 1, Line.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getLine_ContainerArcGraphics(), this.getArcGraphics(), this.getArcGraphics_Line(),
         "containerArcGraphics", null, 0, 1, Line.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getLine_ContainerAnnotationGraphics(), this.getAnnotationGraphics(),
         this.getAnnotationGraphics_Line(), "containerAnnotationGraphics", null, 0, 1, Line.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         !IS_ORDERED);
      initEAttribute(getLine_Style(), this.getLineStyle(), "style", null, 0, 1, Line.class, !IS_TRANSIENT, !IS_VOLATILE,
         IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(arcGraphicsEClass, ArcGraphics.class, "ArcGraphics", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getArcGraphics_Positions(), this.getPosition(), this.getPosition_ContainerArcGraphics(),
         "positions", null, 0, -1, ArcGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getArcGraphics_Line(), this.getLine(), this.getLine_ContainerArcGraphics(), "line", null, 0, 1,
         ArcGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getArcGraphics_ContainerArc(), this.getEdge(), this.getEdge_Arcgraphics(), "containerArc", null, 0,
         1, ArcGraphics.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(arcEClass, Arc.class, "Arc", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getArc_Source(), this.getNode(), this.getNode_OutArcs(), "source", null, 1, 1, Arc.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, !IS_ORDERED);
      initEReference(getArc_Target(), this.getNode(), this.getNode_InArcs(), "target", null, 1, 1, Arc.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, !IS_ORDERED);
      initEReference(getArc_ContainerPage(), this.getPage(), this.getPage_Arc(), "containerPage", null, 0, 1, Arc.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, !IS_ORDERED);
      initEReference(getArc_Toolspecific(), this.getToolInfo(), this.getToolInfo_Arc(), "toolspecific", null, 0, -1,
         Arc.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(nodeEClass, Node.class, "Node", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getNode_InArcs(), this.getArc(), this.getArc_Target(), "InArcs", null, 0, -1, Node.class,
         !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, !IS_ORDERED);
      initEReference(getNode_OutArcs(), this.getArc(), this.getArc_Source(), "OutArcs", null, 0, -1, Node.class,
         !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, !IS_ORDERED);

      initEClass(fontEClass, Font.class, "Font", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getFont_Align(), this.getFontAlign(), "align", "LEFT", 0, 1, Font.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getFont_Decoration(), this.getFontDecoration(), "decoration", "UNDERLINE", 0, 1, Font.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getFont_Family(), this.getCSS2FontFamily(), "family", "VERDANA", 0, 1, Font.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getFont_Rotation(), ecorePackage.getEBigDecimal(), "rotation", null, 0, 1, Font.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getFont_Size(), this.getCSS2FontSize(), "size", "SMALL", 0, 1, Font.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getFont_Style(), this.getCSS2FontStyle(), "style", "NORMAL", 0, 1, Font.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute(getFont_Weight(), this.getCSS2FontWeight(), "weight", null, 0, 1, Font.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getFont_ContainerAnnotationGraphics(), this.getAnnotationGraphics(),
         this.getAnnotationGraphics_Font(), "containerAnnotationGraphics", null, 0, 1, Font.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         !IS_ORDERED);

      initEClass(placeNodeEClass, PlaceNode.class, "PlaceNode", IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getPlaceNode_ReferencingPlaces(), this.getRefPlace(), this.getRefPlace_Ref(), "referencingPlaces",
         null, 0, -1, PlaceNode.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getPlaceNode_InhibitorArcs(), this.getInhibitorArc(), this.getInhibitorArc_Source(),
         "inhibitorArcs", null, 0, -1, PlaceNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPlaceNode_ReadArcs(), this.getReadArc(), this.getReadArc_Source(), "readArcs", null, 0, -1,
         PlaceNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass(transitionNodeEClass, TransitionNode.class, "TransitionNode", IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getTransitionNode_ReferencingTransitions(), this.getRefTransition(), this.getRefTransition_Ref(),
         "referencingTransitions", null, 0, -1, TransitionNode.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE,
         !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getTransitionNode_InhibitorArcs(), this.getInhibitorArc(), this.getInhibitorArc_Target(),
         "inhibitorArcs", null, 0, -1, TransitionNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getTransitionNode_ReadArcs(), this.getReadArc(), this.getReadArc_Target(), "readArcs", null, 0, -1,
         TransitionNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass(placeEClass, Place.class, "Place", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getPlace_InitialMarking(), this.getPTMarking(), this.getPTMarking_ContainerPlace(),
         "initialMarking", null, 0, 1, Place.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getPlace_ContainerPage(), this.getPage(), this.getPage_Place(), "containerPage", null, 0, 1,
         Place.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getPlace_Toolspecific(), this.getToolInfoPlace(), this.getToolInfoPlace_Place(), "toolspecific",
         null, 0, -1, Place.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(refTransitionEClass, RefTransition.class, "RefTransition", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getRefTransition_Ref(), this.getTransitionNode(), this.getTransitionNode_ReferencingTransitions(),
         "ref", null, 1, 1, RefTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getRefTransition_ContainerPage(), this.getPage(), this.getPage_ReferenceTransition(),
         "containerPage", null, 0, 1, RefTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getRefTransition_Toolspecific(), this.getToolInfoNode(), this.getToolInfoNode_RefTransition(),
         "toolspecific", null, 0, -1, RefTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(transitionEClass, Transition.class, "Transition", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getTransition_ContainerPage(), this.getPage(), this.getPage_Transition(), "containerPage", null, 0,
         1, Transition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getTransition_Toolspecific(), this.getToolInfoTransition(),
         this.getToolInfoTransition_Transition(), "toolspecific", null, 0, -1, Transition.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         IS_ORDERED);

      initEClass(refPlaceEClass, RefPlace.class, "RefPlace", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getRefPlace_Ref(), this.getPlaceNode(), this.getPlaceNode_ReferencingPlaces(), "ref", null, 1, 1,
         RefPlace.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getRefPlace_ContainerPage(), this.getPage(), this.getPage_ReferencePlace(), "containerPage", null,
         0, 1, RefPlace.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getRefPlace_Toolspecific(), this.getToolInfoNode(), this.getToolInfoNode_RefPlace(),
         "toolspecific", null, 0, -1, RefPlace.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(attributeEClass, Attribute.class, "Attribute", IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);

      initEClass(annotationEClass, Annotation.class, "Annotation", IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getAnnotation_Annotationgraphics(), this.getAnnotationGraphics(),
         this.getAnnotationGraphics_ContainerAnnotation(), "annotationgraphics", null, 0, 1, Annotation.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
         !IS_DERIVED, !IS_ORDERED);

      initEClass(anyObjectEClass, AnyObject.class, "AnyObject", IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getAnyObject_ContainerToolInfo(), this.getToolInfo(), this.getToolInfo_ToolInfoModel(),
         "containerToolInfo", null, 0, 1, AnyObject.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(edgeEClass, Edge.class, "Edge", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getEdge_Arcgraphics(), this.getArcGraphics(), this.getArcGraphics_ContainerArc(), "arcgraphics",
         null, 0, 1, Edge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getEdge_Inscription(), this.getPTArcAnnotation(), this.getPTArcAnnotation_ContainerArc(),
         "inscription", null, 0, 1, Edge.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(inhibitorArcEClass, InhibitorArc.class, "InhibitorArc", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getInhibitorArc_Page(), this.getPage(), this.getPage_InhibitorArc(), "page", null, 0, 1,
         InhibitorArc.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getInhibitorArc_Source(), this.getPlaceNode(), this.getPlaceNode_InhibitorArcs(), "source", null,
         1, 1, InhibitorArc.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getInhibitorArc_Target(), this.getTransitionNode(), this.getTransitionNode_InhibitorArcs(),
         "target", null, 1, 1, InhibitorArc.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass(readArcEClass, ReadArc.class, "ReadArc", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getReadArc_ContainerPage(), this.getPage(), this.getPage_ReadArc(), "containerPage", null, 0, 1,
         ReadArc.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getReadArc_Source(), this.getPlaceNode(), this.getPlaceNode_ReadArcs(), "source", null, 1, 1,
         ReadArc.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
         IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference(getReadArc_Target(), this.getTransitionNode(), this.getTransitionNode_ReadArcs(), "target", null,
         1, 1, ReadArc.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass(positionableObjectEClass, PositionableObject.class, "PositionableObject", IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getPositionableObject_Nodegraphics(), this.getNodeGraphics(),
         this.getNodeGraphics_ContainerObject(), "nodegraphics", null, 0, 1, PositionableObject.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         !IS_ORDERED);

      initEClass(toolInfoPlaceEClass, ToolInfoPlace.class, "ToolInfoPlace", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getToolInfoPlace_BalloonMarking(), this.getBalloonMarking(),
         this.getBalloonMarking_ToolInfoPlace(), "balloonMarking", null, 0, 1, ToolInfoPlace.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         IS_ORDERED);
      initEReference(getToolInfoPlace_Place(), this.getPlace(), this.getPlace_Toolspecific(), "place", null, 0, 1,
         ToolInfoPlace.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(toolInfoTransitionEClass, ToolInfoTransition.class, "ToolInfoTransition", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getToolInfoTransition_Inputsignalclause(), ecorePackage.getEString(), "inputsignalclause", null, 0,
         1, ToolInfoTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
         !IS_DERIVED, IS_ORDERED);
      initEAttribute(getToolInfoTransition_TopicName(), ecorePackage.getEString(), "topicName", null, 0, 1,
         ToolInfoTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
         !IS_DERIVED, IS_ORDERED);
      initEAttribute(getToolInfoTransition_ServiceName(), ecorePackage.getEString(), "serviceName", null, 0, 1,
         ToolInfoTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
         !IS_DERIVED, IS_ORDERED);
      initEAttribute(getToolInfoTransition_ServerInput(), ecorePackage.getEString(), "serverInput", null, 0, 1,
         ToolInfoTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
         !IS_DERIVED, IS_ORDERED);
      initEAttribute(getToolInfoTransition_ServerOutput(), ecorePackage.getEString(), "serverOutput", null, 0, 1,
         ToolInfoTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
         !IS_DERIVED, IS_ORDERED);
      initEAttribute(getToolInfoTransition_ServerCapacity(), this.getNatural(), "serverCapacity", null, 0, 1,
         ToolInfoTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE,
         !IS_DERIVED, IS_ORDERED);
      initEReference(getToolInfoTransition_Channels(), this.getChannels(), this.getChannels_ToolInfoTransition(),
         "channels", null, 0, 1, ToolInfoTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getToolInfoTransition_Publishers(), this.getPublishers(), this.getPublishers_ToolInfoTransition(),
         "publishers", null, 0, 1, ToolInfoTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getToolInfoTransition_Subscribers(), this.getSubscribers(),
         this.getSubscribers_ToolInfoTransition(), "subscribers", null, 0, 1, ToolInfoTransition.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         IS_ORDERED);
      initEReference(getToolInfoTransition_Transition(), this.getTransition(), this.getTransition_Toolspecific(),
         "transition", null, 0, 1, ToolInfoTransition.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(toolInfoPageEClass, ToolInfoPage.class, "ToolInfoPage", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getToolInfoPage_ServiceName(), ecorePackage.getEString(), "serviceName", null, 0, 1,
         ToolInfoPage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
         IS_ORDERED);
      initEReference(getToolInfoPage_Page(), this.getPage(), this.getPage_Toolspecific(), "page", null, 0, 1,
         ToolInfoPage.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(toolInfoNetEClass, ToolInfoNet.class, "ToolInfoNet", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getToolInfoNet_Inputsignals(), this.getInputSignals(), this.getInputSignals_ToolInfoNet(),
         "inputsignals", null, 0, 1, ToolInfoNet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getToolInfoNet_Petrinet(), this.getPetriNet(), this.getPetriNet_Toolspecific(), "petrinet", null,
         0, 1, ToolInfoNet.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(tokensEClass, Tokens.class, "Tokens", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getTokens_BalloonMarking(), this.getBalloonMarking(), this.getBalloonMarking_Tokens(),
         "balloonMarking", null, 0, 1, Tokens.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEAttribute(getTokens_Token(), ecorePackage.getEString(), "token", null, 0, -1, Tokens.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(balloonMarkingEClass, BalloonMarking.class, "BalloonMarking", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getBalloonMarking_ToolInfoPlace(), this.getToolInfoPlace(), this.getToolInfoPlace_BalloonMarking(),
         "toolInfoPlace", null, 0, 1, BalloonMarking.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getBalloonMarking_Tokens(), this.getTokens(), this.getTokens_BalloonMarking(), "tokens", null, 0,
         1, BalloonMarking.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(inputSignalsEClass, InputSignals.class, "InputSignals", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getInputSignals_ToolInfoNet(), this.getToolInfoNet(), this.getToolInfoNet_Inputsignals(),
         "toolInfoNet", null, 0, 1, InputSignals.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getInputSignals_Inputsignal(), this.getInputSignal(), this.getInputSignal_InputsignalsContainer(),
         "inputsignal", null, 0, -1, InputSignals.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(inputSignalEClass, InputSignal.class, "InputSignal", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getInputSignal_InputsignalsContainer(), this.getInputSignals(), this.getInputSignals_Inputsignal(),
         "inputsignalsContainer", null, 0, 1, InputSignal.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
         !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEAttribute(getInputSignal_InputsignalID(), ecorePackage.getEString(), "inputsignalID", null, 1, 1,
         InputSignal.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
         IS_ORDERED);
      initEAttribute(getInputSignal_Initialvalue(), ecorePackage.getEBoolean(), "initialvalue", null, 0, 1,
         InputSignal.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
         IS_ORDERED);

      initEClass(channelsEClass, Channels.class, "Channels", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference(getChannels_ToolInfoTransition(), this.getToolInfoTransition(),
         this.getToolInfoTransition_Channels(), "toolInfoTransition", null, 0, 1, Channels.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         IS_ORDERED);
      initEReference(getChannels_Channel(), this.getChannel(), this.getChannel_ChannelsContainer(), "channel", null, 0,
         -1, Channels.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(channelEClass, Channel.class, "Channel", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getChannel_Cid(), ecorePackage.getEString(), "cid", null, 1, 1, Channel.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEAttribute(getChannel_Request(), ecorePackage.getEString(), "request", null, 1, 1, Channel.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEAttribute(getChannel_Response(), ecorePackage.getEString(), "response", null, 1, 1, Channel.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getChannel_ChannelsContainer(), this.getChannels(), this.getChannels_Channel(),
         "channelsContainer", null, 0, 1, Channel.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(publishersEClass, Publishers.class, "Publishers", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getPublishers_ToolInfoTransition(), this.getToolInfoTransition(),
         this.getToolInfoTransition_Publishers(), "toolInfoTransition", null, 0, 1, Publishers.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         IS_ORDERED);
      initEReference(getPublishers_Publisher(), this.getPublisher(), this.getPublisher_PublishersContainer(),
         "publisher", null, 0, -1, Publishers.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(publisherEClass, Publisher.class, "Publisher", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getPublisher_Id(), ecorePackage.getEString(), "id", null, 1, 1, Publisher.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEAttribute(getPublisher_Limit(), this.getNatural(), "limit", null, 1, 1, Publisher.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getPublisher_PublishersContainer(), this.getPublishers(), this.getPublishers_Publisher(),
         "publishersContainer", null, 0, 1, Publisher.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(subscribersEClass, Subscribers.class, "Subscribers", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEReference(getSubscribers_ToolInfoTransition(), this.getToolInfoTransition(),
         this.getToolInfoTransition_Subscribers(), "toolInfoTransition", null, 0, 1, Subscribers.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
         IS_ORDERED);
      initEReference(getSubscribers_Subscriber(), this.getSubscriber(), this.getSubscriber_SubscribersContainer(),
         "subscriber", null, 0, -1, Subscribers.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(subscriberEClass, Subscriber.class, "Subscriber", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getSubscriber_Id(), ecorePackage.getEString(), "id", null, 1, 1, Subscriber.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEAttribute(getSubscriber_Limit(), this.getNatural(), "limit", null, 1, 1, Subscriber.class, !IS_TRANSIENT,
         !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getSubscriber_SubscribersContainer(), this.getSubscribers(), this.getSubscribers_Subscriber(),
         "subscribersContainer", null, 0, 1, Subscriber.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE,
         !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass(toolInfoNodeEClass, ToolInfoNode.class, "ToolInfoNode", !IS_ABSTRACT, !IS_INTERFACE,
         IS_GENERATED_INSTANCE_CLASS);
      initEAttribute(getToolInfoNode_Node(), ecorePackage.getEString(), "node", null, 0, 1, ToolInfoNode.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEAttribute(getToolInfoNode_Subnet(), ecorePackage.getEString(), "subnet", null, 0, 1, ToolInfoNode.class,
         !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getToolInfoNode_RefTransition(), this.getRefTransition(), this.getRefTransition_Toolspecific(),
         "refTransition", null, 0, 1, ToolInfoNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
         !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference(getToolInfoNode_RefPlace(), this.getRefPlace(), this.getRefPlace_Toolspecific(), "refPlace", null,
         0, 1, ToolInfoNode.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
         !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      // Initialize enums and add enum literals
      initEEnum(pnTypeEEnum, PNType.class, "PNType");
      addEEnumLiteral(pnTypeEEnum, PNType.PTNET);
      addEEnumLiteral(pnTypeEEnum, PNType.COREMODEL);
      addEEnumLiteral(pnTypeEEnum, PNType.SYMNET);
      addEEnumLiteral(pnTypeEEnum, PNType.HLPN);

      initEEnum(css2ColorEEnum, CSS2Color.class, "CSS2Color");
      addEEnumLiteral(css2ColorEEnum, CSS2Color.AQUA);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.BLACK);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.BLUE);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.FUCHSIA);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.GRAY);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.GREEN);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.LIME);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.MAROON);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.NAVY);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.OLIVE);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.ORANGE);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.PURPLE);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.RED);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.SILVER);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.TEAL);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.WHITE);
      addEEnumLiteral(css2ColorEEnum, CSS2Color.YELLOW);

      initEEnum(gradientEEnum, Gradient.class, "Gradient");
      addEEnumLiteral(gradientEEnum, Gradient.HORIZONTAL);
      addEEnumLiteral(gradientEEnum, Gradient.VERTICAL);
      addEEnumLiteral(gradientEEnum, Gradient.DIAGONAL);

      initEEnum(lineShapeEEnum, LineShape.class, "LineShape");
      addEEnumLiteral(lineShapeEEnum, LineShape.LINE);
      addEEnumLiteral(lineShapeEEnum, LineShape.CURVE);

      initEEnum(fontAlignEEnum, FontAlign.class, "FontAlign");
      addEEnumLiteral(fontAlignEEnum, FontAlign.LEFT);
      addEEnumLiteral(fontAlignEEnum, FontAlign.CENTER);
      addEEnumLiteral(fontAlignEEnum, FontAlign.RIGHT);

      initEEnum(fontDecorationEEnum, FontDecoration.class, "FontDecoration");
      addEEnumLiteral(fontDecorationEEnum, FontDecoration.UNDERLINE);
      addEEnumLiteral(fontDecorationEEnum, FontDecoration.OVERLINE);
      addEEnumLiteral(fontDecorationEEnum, FontDecoration.LINETHROUGH);

      initEEnum(css2FontFamilyEEnum, CSS2FontFamily.class, "CSS2FontFamily");
      addEEnumLiteral(css2FontFamilyEEnum, CSS2FontFamily.VERDANA);
      addEEnumLiteral(css2FontFamilyEEnum, CSS2FontFamily.ARIAL);
      addEEnumLiteral(css2FontFamilyEEnum, CSS2FontFamily.TIMES);
      addEEnumLiteral(css2FontFamilyEEnum, CSS2FontFamily.GEORGIA);
      addEEnumLiteral(css2FontFamilyEEnum, CSS2FontFamily.TREBUCHET);

      initEEnum(css2FontSizeEEnum, CSS2FontSize.class, "CSS2FontSize");
      addEEnumLiteral(css2FontSizeEEnum, CSS2FontSize.XXSMALL);
      addEEnumLiteral(css2FontSizeEEnum, CSS2FontSize.XSMALL);
      addEEnumLiteral(css2FontSizeEEnum, CSS2FontSize.SMALL);
      addEEnumLiteral(css2FontSizeEEnum, CSS2FontSize.MEDIUM);
      addEEnumLiteral(css2FontSizeEEnum, CSS2FontSize.LARGE);
      addEEnumLiteral(css2FontSizeEEnum, CSS2FontSize.XLARGE);
      addEEnumLiteral(css2FontSizeEEnum, CSS2FontSize.XXLARGE);

      initEEnum(css2FontStyleEEnum, CSS2FontStyle.class, "CSS2FontStyle");
      addEEnumLiteral(css2FontStyleEEnum, CSS2FontStyle.NORMAL);
      addEEnumLiteral(css2FontStyleEEnum, CSS2FontStyle.ITALIC);
      addEEnumLiteral(css2FontStyleEEnum, CSS2FontStyle.OBLIQUE);

      initEEnum(css2FontWeightEEnum, CSS2FontWeight.class, "CSS2FontWeight");
      addEEnumLiteral(css2FontWeightEEnum, CSS2FontWeight.NORMAL);
      addEEnumLiteral(css2FontWeightEEnum, CSS2FontWeight.BOLD);
      addEEnumLiteral(css2FontWeightEEnum, CSS2FontWeight.BOLDER);
      addEEnumLiteral(css2FontWeightEEnum, CSS2FontWeight.LIGHTER);

      initEEnum(lineStyleEEnum, LineStyle.class, "LineStyle");
      addEEnumLiteral(lineStyleEEnum, LineStyle.SOLID);
      addEEnumLiteral(lineStyleEEnum, LineStyle.DASH);
      addEEnumLiteral(lineStyleEEnum, LineStyle.DOT);

      // Initialize data types
      initEDataType(positiveIntegerEDataType, Integer.class, "PositiveInteger", IS_SERIALIZABLE,
         !IS_GENERATED_INSTANCE_CLASS);
      initEDataType(naturalEDataType, Integer.class, "Natural", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
      initEDataType(uriEDataType, java.net.URI.class, "URI", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
      initEDataType(longStringEDataType, StringBuffer.class, "LongString", IS_SERIALIZABLE,
         !IS_GENERATED_INSTANCE_CLASS);

      // Create resource
      createResource(eNS_URI);

      // Create annotations
      // http://www.pnml.org/models/OCL
      createOCLAnnotations();
      // http://www.eclipse.org/emf/2002/Ecore
      createEcoreAnnotations();
   }

   /**
    * Initializes the annotations for <b>http://www.pnml.org/models/OCL</b>.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected void createOCLAnnotations() {
      String source = "http://www.pnml.org/models/OCL";
      addAnnotation(ptMarkingEClass,
         source,
         new String[] {
            "markingValueRange", "self.text >= 0"
         });
      addAnnotation(ptArcAnnotationEClass,
         source,
         new String[] {
            "inscriptionValueRange", "self.text > 0"
         });
      addAnnotation(arcEClass,
         source,
         new String[] {
            "samePageSourceTarget", "self.source.containerPage = self.target.containerPage",
            "differentSourceTarget",
            "(self.source.oclIsKindOf(PlaceNode) and self.target.oclIsKindOf(TransitionNode)) or (self.source.oclIsKindOf(TransitionNode) and self.target.oclIsKindOf(PlaceNode))"
         });
   }

   /**
    * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected void createEcoreAnnotations() {
      String source = "http://www.eclipse.org/emf/2002/Ecore";
      addAnnotation(ptMarkingEClass,
         source,
         new String[] {
            "constraints", "markingValueRange"
         });
      addAnnotation(ptArcAnnotationEClass,
         source,
         new String[] {
            "constraints", "inscriptionValueRange"
         });
      addAnnotation(arcEClass,
         source,
         new String[] {
            "constraints", "samePageSourceTarget differentSourceTarget"
         });
   }

} //PtnetPackageImpl
