/**
 */
package org.pnml.emf.ptnet.impl;

import java.util.Collection;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.pnml.emf.ptnet.InhibitorArc;
import org.pnml.emf.ptnet.PtnetPackage;
import org.pnml.emf.ptnet.ReadArc;
import org.pnml.emf.ptnet.RefTransition;
import org.pnml.emf.ptnet.TransitionNode;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Transition Node</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.pnml.emf.ptnet.impl.TransitionNodeImpl#getReferencingTransitions <em>Referencing Transitions</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.TransitionNodeImpl#getInhibitorArcs <em>Inhibitor Arcs</em>}</li>
 *   <li>{@link org.pnml.emf.ptnet.impl.TransitionNodeImpl#getReadArcs <em>Read Arcs</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class TransitionNodeImpl extends NodeImpl implements TransitionNode {
   /**
    * The cached value of the '{@link #getReferencingTransitions() <em>Referencing Transitions</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getReferencingTransitions()
    * @generated
    * @ordered
    */
   protected EList<RefTransition> referencingTransitions;

   /**
    * The cached value of the '{@link #getInhibitorArcs() <em>Inhibitor Arcs</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getInhibitorArcs()
    * @generated
    * @ordered
    */
   protected EList<InhibitorArc> inhibitorArcs;
   /**
    * The cached value of the '{@link #getReadArcs() <em>Read Arcs</em>}' reference list.
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @see #getReadArcs()
    * @generated
    * @ordered
    */
   protected EList<ReadArc> readArcs;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected TransitionNodeImpl() {
      super();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass() {
      return PtnetPackage.Literals.TRANSITION_NODE;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<RefTransition> getReferencingTransitions() {
      if (referencingTransitions == null) {
         referencingTransitions = new EObjectWithInverseResolvingEList<RefTransition>(RefTransition.class, this,
            PtnetPackage.TRANSITION_NODE__REFERENCING_TRANSITIONS, PtnetPackage.REF_TRANSITION__REF);
      }
      return referencingTransitions;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<InhibitorArc> getInhibitorArcs() {
      if (inhibitorArcs == null) {
         inhibitorArcs = new EObjectWithInverseResolvingEList<InhibitorArc>(InhibitorArc.class, this,
            PtnetPackage.TRANSITION_NODE__INHIBITOR_ARCS, PtnetPackage.INHIBITOR_ARC__TARGET);
      }
      return inhibitorArcs;
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<ReadArc> getReadArcs() {
      if (readArcs == null) {
         readArcs = new EObjectWithInverseResolvingEList<ReadArc>(ReadArc.class, this,
            PtnetPackage.TRANSITION_NODE__READ_ARCS, PtnetPackage.READ_ARC__TARGET);
      }
      return readArcs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
      switch (featureID) {
         case PtnetPackage.TRANSITION_NODE__REFERENCING_TRANSITIONS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getReferencingTransitions()).basicAdd(otherEnd,
               msgs);
         case PtnetPackage.TRANSITION_NODE__INHIBITOR_ARCS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getInhibitorArcs()).basicAdd(otherEnd, msgs);
         case PtnetPackage.TRANSITION_NODE__READ_ARCS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getReadArcs()).basicAdd(otherEnd, msgs);
      }
      return super.eInverseAdd(otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
      switch (featureID) {
         case PtnetPackage.TRANSITION_NODE__REFERENCING_TRANSITIONS:
            return ((InternalEList<?>) getReferencingTransitions()).basicRemove(otherEnd, msgs);
         case PtnetPackage.TRANSITION_NODE__INHIBITOR_ARCS:
            return ((InternalEList<?>) getInhibitorArcs()).basicRemove(otherEnd, msgs);
         case PtnetPackage.TRANSITION_NODE__READ_ARCS:
            return ((InternalEList<?>) getReadArcs()).basicRemove(otherEnd, msgs);
      }
      return super.eInverseRemove(otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet(int featureID, boolean resolve, boolean coreType) {
      switch (featureID) {
         case PtnetPackage.TRANSITION_NODE__REFERENCING_TRANSITIONS:
            return getReferencingTransitions();
         case PtnetPackage.TRANSITION_NODE__INHIBITOR_ARCS:
            return getInhibitorArcs();
         case PtnetPackage.TRANSITION_NODE__READ_ARCS:
            return getReadArcs();
      }
      return super.eGet(featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet(int featureID, Object newValue) {
      switch (featureID) {
         case PtnetPackage.TRANSITION_NODE__INHIBITOR_ARCS:
            getInhibitorArcs().clear();
            getInhibitorArcs().addAll((Collection<? extends InhibitorArc>) newValue);
            return;
         case PtnetPackage.TRANSITION_NODE__READ_ARCS:
            getReadArcs().clear();
            getReadArcs().addAll((Collection<? extends ReadArc>) newValue);
            return;
      }
      super.eSet(featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
   	 * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset(int featureID) {
      switch (featureID) {
         case PtnetPackage.TRANSITION_NODE__INHIBITOR_ARCS:
            getInhibitorArcs().clear();
            return;
         case PtnetPackage.TRANSITION_NODE__READ_ARCS:
            getReadArcs().clear();
            return;
      }
      super.eUnset(featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet(int featureID) {
      switch (featureID) {
         case PtnetPackage.TRANSITION_NODE__REFERENCING_TRANSITIONS:
            return referencingTransitions != null && !referencingTransitions.isEmpty();
         case PtnetPackage.TRANSITION_NODE__INHIBITOR_ARCS:
            return inhibitorArcs != null && !inhibitorArcs.isEmpty();
         case PtnetPackage.TRANSITION_NODE__READ_ARCS:
            return readArcs != null && !readArcs.isEmpty();
      }
      return super.eIsSet(featureID);
   }

} //TransitionNodeImpl
