/**
 */
package org.pnml.emf.ptnet.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import org.pnml.emf.ptnet.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.pnml.emf.ptnet.PtnetPackage
 * @generated
 */
public class PtnetAdapterFactory extends AdapterFactoryImpl {
   /**
    * The cached model package.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected static PtnetPackage modelPackage;

   /**
    * Creates an instance of the adapter factory.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public PtnetAdapterFactory() {
      if (modelPackage == null) {
         modelPackage = PtnetPackage.eINSTANCE;
      }
   }

   /**
    * Returns whether this factory is applicable for the type of the object.
    * <!-- begin-user-doc -->
    * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
    * <!-- end-user-doc -->
    * @return whether this factory is applicable for the type of the object.
    * @generated
    */
   @Override
   public boolean isFactoryForType(Object object) {
      if (object == modelPackage) {
         return true;
      }
      if (object instanceof EObject) {
         return ((EObject) object).eClass().getEPackage() == modelPackage;
      }
      return false;
   }

   /**
    * The switch that delegates to the <code>createXXX</code> methods.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected PtnetSwitch<Adapter> modelSwitch = new PtnetSwitch<Adapter>() {
      @Override
      public Adapter casePTMarking(PTMarking object) {
         return createPTMarkingAdapter();
      }

      @Override
      public Adapter casePTArcAnnotation(PTArcAnnotation object) {
         return createPTArcAnnotationAdapter();
      }

      @Override
      public Adapter casepnml(pnml object) {
         return createpnmlAdapter();
      }

      @Override
      public Adapter casePetriNet(PetriNet object) {
         return createPetriNetAdapter();
      }

      @Override
      public Adapter casePage(Page object) {
         return createPageAdapter();
      }

      @Override
      public Adapter casePnObject(PnObject object) {
         return createPnObjectAdapter();
      }

      @Override
      public Adapter caseName(Name object) {
         return createNameAdapter();
      }

      @Override
      public Adapter caseToolInfo(ToolInfo object) {
         return createToolInfoAdapter();
      }

      @Override
      public Adapter caseLabel(Label object) {
         return createLabelAdapter();
      }

      @Override
      public Adapter caseNodeGraphics(NodeGraphics object) {
         return createNodeGraphicsAdapter();
      }

      @Override
      public Adapter caseGraphics(Graphics object) {
         return createGraphicsAdapter();
      }

      @Override
      public Adapter caseCoordinate(Coordinate object) {
         return createCoordinateAdapter();
      }

      @Override
      public Adapter casePosition(Position object) {
         return createPositionAdapter();
      }

      @Override
      public Adapter caseOffset(Offset object) {
         return createOffsetAdapter();
      }

      @Override
      public Adapter caseDimension(Dimension object) {
         return createDimensionAdapter();
      }

      @Override
      public Adapter caseAnnotationGraphics(AnnotationGraphics object) {
         return createAnnotationGraphicsAdapter();
      }

      @Override
      public Adapter caseFill(Fill object) {
         return createFillAdapter();
      }

      @Override
      public Adapter caseLine(Line object) {
         return createLineAdapter();
      }

      @Override
      public Adapter caseArcGraphics(ArcGraphics object) {
         return createArcGraphicsAdapter();
      }

      @Override
      public Adapter caseArc(Arc object) {
         return createArcAdapter();
      }

      @Override
      public Adapter caseNode(Node object) {
         return createNodeAdapter();
      }

      @Override
      public Adapter caseFont(Font object) {
         return createFontAdapter();
      }

      @Override
      public Adapter casePlaceNode(PlaceNode object) {
         return createPlaceNodeAdapter();
      }

      @Override
      public Adapter caseTransitionNode(TransitionNode object) {
         return createTransitionNodeAdapter();
      }

      @Override
      public Adapter casePlace(Place object) {
         return createPlaceAdapter();
      }

      @Override
      public Adapter caseRefTransition(RefTransition object) {
         return createRefTransitionAdapter();
      }

      @Override
      public Adapter caseTransition(Transition object) {
         return createTransitionAdapter();
      }

      @Override
      public Adapter caseRefPlace(RefPlace object) {
         return createRefPlaceAdapter();
      }

      @Override
      public Adapter caseAttribute(Attribute object) {
         return createAttributeAdapter();
      }

      @Override
      public Adapter caseAnnotation(Annotation object) {
         return createAnnotationAdapter();
      }

      @Override
      public Adapter caseAnyObject(AnyObject object) {
         return createAnyObjectAdapter();
      }

      @Override
      public Adapter caseEdge(Edge object) {
         return createEdgeAdapter();
      }

      @Override
      public Adapter caseInhibitorArc(InhibitorArc object) {
         return createInhibitorArcAdapter();
      }

      @Override
      public Adapter caseReadArc(ReadArc object) {
         return createReadArcAdapter();
      }

      @Override
      public Adapter casePositionableObject(PositionableObject object) {
         return createPositionableObjectAdapter();
      }

      @Override
      public Adapter caseToolInfoPlace(ToolInfoPlace object) {
         return createToolInfoPlaceAdapter();
      }

      @Override
      public Adapter caseToolInfoTransition(ToolInfoTransition object) {
         return createToolInfoTransitionAdapter();
      }

      @Override
      public Adapter caseToolInfoPage(ToolInfoPage object) {
         return createToolInfoPageAdapter();
      }

      @Override
      public Adapter caseToolInfoNet(ToolInfoNet object) {
         return createToolInfoNetAdapter();
      }

      @Override
      public Adapter caseTokens(Tokens object) {
         return createTokensAdapter();
      }

      @Override
      public Adapter caseBalloonMarking(BalloonMarking object) {
         return createBalloonMarkingAdapter();
      }

      @Override
      public Adapter caseInputSignals(InputSignals object) {
         return createInputSignalsAdapter();
      }

      @Override
      public Adapter caseInputSignal(InputSignal object) {
         return createInputSignalAdapter();
      }

      @Override
      public Adapter caseChannels(Channels object) {
         return createChannelsAdapter();
      }

      @Override
      public Adapter caseChannel(Channel object) {
         return createChannelAdapter();
      }

      @Override
      public Adapter casePublishers(Publishers object) {
         return createPublishersAdapter();
      }

      @Override
      public Adapter casePublisher(Publisher object) {
         return createPublisherAdapter();
      }

      @Override
      public Adapter caseSubscribers(Subscribers object) {
         return createSubscribersAdapter();
      }

      @Override
      public Adapter caseSubscriber(Subscriber object) {
         return createSubscriberAdapter();
      }

      @Override
      public Adapter caseToolInfoNode(ToolInfoNode object) {
         return createToolInfoNodeAdapter();
      }

      @Override
      public Adapter defaultCase(EObject object) {
         return createEObjectAdapter();
      }
   };

   /**
    * Creates an adapter for the <code>target</code>.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param target the object to adapt.
    * @return the adapter for the <code>target</code>.
    * @generated
    */
   @Override
   public Adapter createAdapter(Notifier target) {
      return modelSwitch.doSwitch((EObject) target);
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.PTMarking <em>PT Marking</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.PTMarking
    * @generated
    */
   public Adapter createPTMarkingAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.PTArcAnnotation <em>PT Arc Annotation</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.PTArcAnnotation
    * @generated
    */
   public Adapter createPTArcAnnotationAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.pnml <em>pnml</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.pnml
    * @generated
    */
   public Adapter createpnmlAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.PetriNet <em>Petri Net</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.PetriNet
    * @generated
    */
   public Adapter createPetriNetAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Page <em>Page</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Page
    * @generated
    */
   public Adapter createPageAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.PnObject <em>Pn Object</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.PnObject
    * @generated
    */
   public Adapter createPnObjectAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Name <em>Name</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Name
    * @generated
    */
   public Adapter createNameAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.ToolInfo <em>Tool Info</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.ToolInfo
    * @generated
    */
   public Adapter createToolInfoAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Label <em>Label</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Label
    * @generated
    */
   public Adapter createLabelAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.NodeGraphics <em>Node Graphics</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.NodeGraphics
    * @generated
    */
   public Adapter createNodeGraphicsAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Graphics <em>Graphics</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Graphics
    * @generated
    */
   public Adapter createGraphicsAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Coordinate <em>Coordinate</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Coordinate
    * @generated
    */
   public Adapter createCoordinateAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Position <em>Position</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Position
    * @generated
    */
   public Adapter createPositionAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Offset <em>Offset</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Offset
    * @generated
    */
   public Adapter createOffsetAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Dimension <em>Dimension</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Dimension
    * @generated
    */
   public Adapter createDimensionAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.AnnotationGraphics <em>Annotation Graphics</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.AnnotationGraphics
    * @generated
    */
   public Adapter createAnnotationGraphicsAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Fill <em>Fill</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Fill
    * @generated
    */
   public Adapter createFillAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Line <em>Line</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Line
    * @generated
    */
   public Adapter createLineAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.ArcGraphics <em>Arc Graphics</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.ArcGraphics
    * @generated
    */
   public Adapter createArcGraphicsAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Arc <em>Arc</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Arc
    * @generated
    */
   public Adapter createArcAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Node <em>Node</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Node
    * @generated
    */
   public Adapter createNodeAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Font <em>Font</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Font
    * @generated
    */
   public Adapter createFontAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.PlaceNode <em>Place Node</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.PlaceNode
    * @generated
    */
   public Adapter createPlaceNodeAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.TransitionNode <em>Transition Node</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.TransitionNode
    * @generated
    */
   public Adapter createTransitionNodeAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Place <em>Place</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Place
    * @generated
    */
   public Adapter createPlaceAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.RefTransition <em>Ref Transition</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.RefTransition
    * @generated
    */
   public Adapter createRefTransitionAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Transition <em>Transition</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Transition
    * @generated
    */
   public Adapter createTransitionAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.RefPlace <em>Ref Place</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.RefPlace
    * @generated
    */
   public Adapter createRefPlaceAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Attribute <em>Attribute</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Attribute
    * @generated
    */
   public Adapter createAttributeAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Annotation <em>Annotation</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Annotation
    * @generated
    */
   public Adapter createAnnotationAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.AnyObject <em>Any Object</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.AnyObject
    * @generated
    */
   public Adapter createAnyObjectAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Edge <em>Edge</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Edge
    * @generated
    */
   public Adapter createEdgeAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.InhibitorArc <em>Inhibitor Arc</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.InhibitorArc
    * @generated
    */
   public Adapter createInhibitorArcAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.ReadArc <em>Read Arc</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.ReadArc
    * @generated
    */
   public Adapter createReadArcAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.PositionableObject <em>Positionable Object</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.PositionableObject
    * @generated
    */
   public Adapter createPositionableObjectAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.ToolInfoPlace <em>Tool Info Place</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.ToolInfoPlace
    * @generated
    */
   public Adapter createToolInfoPlaceAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.ToolInfoTransition <em>Tool Info Transition</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.ToolInfoTransition
    * @generated
    */
   public Adapter createToolInfoTransitionAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.ToolInfoPage <em>Tool Info Page</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.ToolInfoPage
    * @generated
    */
   public Adapter createToolInfoPageAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.ToolInfoNet <em>Tool Info Net</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.ToolInfoNet
    * @generated
    */
   public Adapter createToolInfoNetAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Tokens <em>Tokens</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Tokens
    * @generated
    */
   public Adapter createTokensAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.BalloonMarking <em>Balloon Marking</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.BalloonMarking
    * @generated
    */
   public Adapter createBalloonMarkingAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.InputSignals <em>Input Signals</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.InputSignals
    * @generated
    */
   public Adapter createInputSignalsAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.InputSignal <em>Input Signal</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.InputSignal
    * @generated
    */
   public Adapter createInputSignalAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Channels <em>Channels</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Channels
    * @generated
    */
   public Adapter createChannelsAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Channel <em>Channel</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Channel
    * @generated
    */
   public Adapter createChannelAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Publishers <em>Publishers</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Publishers
    * @generated
    */
   public Adapter createPublishersAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Publisher <em>Publisher</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Publisher
    * @generated
    */
   public Adapter createPublisherAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Subscribers <em>Subscribers</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Subscribers
    * @generated
    */
   public Adapter createSubscribersAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.Subscriber <em>Subscriber</em>}'.
    * <!-- begin-user-doc -->
   	 * This default implementation returns null so that we can easily ignore cases;
   	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
   	 * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.Subscriber
    * @generated
    */
   public Adapter createSubscriberAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link org.pnml.emf.ptnet.ToolInfoNode <em>Tool Info Node</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see org.pnml.emf.ptnet.ToolInfoNode
    * @generated
    */
   public Adapter createToolInfoNodeAdapter() {
      return null;
   }

   /**
    * Creates a new adapter for the default case.
    * <!-- begin-user-doc -->
    * This default implementation returns null.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @generated
    */
   public Adapter createEObjectAdapter() {
      return null;
   }

} //PtnetAdapterFactory
