/**
 */
package org.pnml.emf.ptnet.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

import org.pnml.emf.ptnet.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.pnml.emf.ptnet.PtnetPackage
 * @generated
 */
public class PtnetSwitch<T> extends Switch<T> {
   /**
    * The cached model package
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected static PtnetPackage modelPackage;

   /**
    * Creates an instance of the switch.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public PtnetSwitch() {
      if (modelPackage == null) {
         modelPackage = PtnetPackage.eINSTANCE;
      }
   }

   /**
    * Checks whether this is a switch for the given package.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param ePackage the package in question.
    * @return whether this is a switch for the given package.
    * @generated
    */
   @Override
   protected boolean isSwitchFor(EPackage ePackage) {
      return ePackage == modelPackage;
   }

   /**
    * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the first non-null result returned by a <code>caseXXX</code> call.
    * @generated
    */
   @Override
   protected T doSwitch(int classifierID, EObject theEObject) {
      switch (classifierID) {
         case PtnetPackage.PT_MARKING: {
            PTMarking ptMarking = (PTMarking) theEObject;
            T result = casePTMarking(ptMarking);
            if (result == null)
               result = caseAnnotation(ptMarking);
            if (result == null)
               result = caseLabel(ptMarking);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.PT_ARC_ANNOTATION: {
            PTArcAnnotation ptArcAnnotation = (PTArcAnnotation) theEObject;
            T result = casePTArcAnnotation(ptArcAnnotation);
            if (result == null)
               result = caseAnnotation(ptArcAnnotation);
            if (result == null)
               result = caseLabel(ptArcAnnotation);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.PNML: {
            pnml pnml = (pnml) theEObject;
            T result = casepnml(pnml);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.PETRI_NET: {
            PetriNet petriNet = (PetriNet) theEObject;
            T result = casePetriNet(petriNet);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.PAGE: {
            Page page = (Page) theEObject;
            T result = casePage(page);
            if (result == null)
               result = casePositionableObject(page);
            if (result == null)
               result = casePnObject(page);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.PN_OBJECT: {
            PnObject pnObject = (PnObject) theEObject;
            T result = casePnObject(pnObject);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.NAME: {
            Name name = (Name) theEObject;
            T result = caseName(name);
            if (result == null)
               result = caseAnnotation(name);
            if (result == null)
               result = caseLabel(name);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.TOOL_INFO: {
            ToolInfo toolInfo = (ToolInfo) theEObject;
            T result = caseToolInfo(toolInfo);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.LABEL: {
            Label label = (Label) theEObject;
            T result = caseLabel(label);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.NODE_GRAPHICS: {
            NodeGraphics nodeGraphics = (NodeGraphics) theEObject;
            T result = caseNodeGraphics(nodeGraphics);
            if (result == null)
               result = caseGraphics(nodeGraphics);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.GRAPHICS: {
            Graphics graphics = (Graphics) theEObject;
            T result = caseGraphics(graphics);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.COORDINATE: {
            Coordinate coordinate = (Coordinate) theEObject;
            T result = caseCoordinate(coordinate);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.POSITION: {
            Position position = (Position) theEObject;
            T result = casePosition(position);
            if (result == null)
               result = caseCoordinate(position);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.OFFSET: {
            Offset offset = (Offset) theEObject;
            T result = caseOffset(offset);
            if (result == null)
               result = caseCoordinate(offset);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.DIMENSION: {
            Dimension dimension = (Dimension) theEObject;
            T result = caseDimension(dimension);
            if (result == null)
               result = caseCoordinate(dimension);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.ANNOTATION_GRAPHICS: {
            AnnotationGraphics annotationGraphics = (AnnotationGraphics) theEObject;
            T result = caseAnnotationGraphics(annotationGraphics);
            if (result == null)
               result = caseGraphics(annotationGraphics);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.FILL: {
            Fill fill = (Fill) theEObject;
            T result = caseFill(fill);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.LINE: {
            Line line = (Line) theEObject;
            T result = caseLine(line);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.ARC_GRAPHICS: {
            ArcGraphics arcGraphics = (ArcGraphics) theEObject;
            T result = caseArcGraphics(arcGraphics);
            if (result == null)
               result = caseGraphics(arcGraphics);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.ARC: {
            Arc arc = (Arc) theEObject;
            T result = caseArc(arc);
            if (result == null)
               result = caseEdge(arc);
            if (result == null)
               result = casePnObject(arc);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.NODE: {
            Node node = (Node) theEObject;
            T result = caseNode(node);
            if (result == null)
               result = casePositionableObject(node);
            if (result == null)
               result = casePnObject(node);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.FONT: {
            Font font = (Font) theEObject;
            T result = caseFont(font);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.PLACE_NODE: {
            PlaceNode placeNode = (PlaceNode) theEObject;
            T result = casePlaceNode(placeNode);
            if (result == null)
               result = caseNode(placeNode);
            if (result == null)
               result = casePositionableObject(placeNode);
            if (result == null)
               result = casePnObject(placeNode);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.TRANSITION_NODE: {
            TransitionNode transitionNode = (TransitionNode) theEObject;
            T result = caseTransitionNode(transitionNode);
            if (result == null)
               result = caseNode(transitionNode);
            if (result == null)
               result = casePositionableObject(transitionNode);
            if (result == null)
               result = casePnObject(transitionNode);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.PLACE: {
            Place place = (Place) theEObject;
            T result = casePlace(place);
            if (result == null)
               result = casePlaceNode(place);
            if (result == null)
               result = caseNode(place);
            if (result == null)
               result = casePositionableObject(place);
            if (result == null)
               result = casePnObject(place);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.REF_TRANSITION: {
            RefTransition refTransition = (RefTransition) theEObject;
            T result = caseRefTransition(refTransition);
            if (result == null)
               result = caseTransitionNode(refTransition);
            if (result == null)
               result = caseNode(refTransition);
            if (result == null)
               result = casePositionableObject(refTransition);
            if (result == null)
               result = casePnObject(refTransition);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.TRANSITION: {
            Transition transition = (Transition) theEObject;
            T result = caseTransition(transition);
            if (result == null)
               result = caseTransitionNode(transition);
            if (result == null)
               result = caseNode(transition);
            if (result == null)
               result = casePositionableObject(transition);
            if (result == null)
               result = casePnObject(transition);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.REF_PLACE: {
            RefPlace refPlace = (RefPlace) theEObject;
            T result = caseRefPlace(refPlace);
            if (result == null)
               result = casePlaceNode(refPlace);
            if (result == null)
               result = caseNode(refPlace);
            if (result == null)
               result = casePositionableObject(refPlace);
            if (result == null)
               result = casePnObject(refPlace);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.ATTRIBUTE: {
            Attribute attribute = (Attribute) theEObject;
            T result = caseAttribute(attribute);
            if (result == null)
               result = caseLabel(attribute);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.ANNOTATION: {
            Annotation annotation = (Annotation) theEObject;
            T result = caseAnnotation(annotation);
            if (result == null)
               result = caseLabel(annotation);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.ANY_OBJECT: {
            AnyObject anyObject = (AnyObject) theEObject;
            T result = caseAnyObject(anyObject);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.EDGE: {
            Edge edge = (Edge) theEObject;
            T result = caseEdge(edge);
            if (result == null)
               result = casePnObject(edge);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.INHIBITOR_ARC: {
            InhibitorArc inhibitorArc = (InhibitorArc) theEObject;
            T result = caseInhibitorArc(inhibitorArc);
            if (result == null)
               result = caseEdge(inhibitorArc);
            if (result == null)
               result = casePnObject(inhibitorArc);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.READ_ARC: {
            ReadArc readArc = (ReadArc) theEObject;
            T result = caseReadArc(readArc);
            if (result == null)
               result = caseEdge(readArc);
            if (result == null)
               result = casePnObject(readArc);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.POSITIONABLE_OBJECT: {
            PositionableObject positionableObject = (PositionableObject) theEObject;
            T result = casePositionableObject(positionableObject);
            if (result == null)
               result = casePnObject(positionableObject);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.TOOL_INFO_PLACE: {
            ToolInfoPlace toolInfoPlace = (ToolInfoPlace) theEObject;
            T result = caseToolInfoPlace(toolInfoPlace);
            if (result == null)
               result = caseToolInfoNode(toolInfoPlace);
            if (result == null)
               result = caseToolInfo(toolInfoPlace);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.TOOL_INFO_TRANSITION: {
            ToolInfoTransition toolInfoTransition = (ToolInfoTransition) theEObject;
            T result = caseToolInfoTransition(toolInfoTransition);
            if (result == null)
               result = caseToolInfoNode(toolInfoTransition);
            if (result == null)
               result = caseToolInfo(toolInfoTransition);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.TOOL_INFO_PAGE: {
            ToolInfoPage toolInfoPage = (ToolInfoPage) theEObject;
            T result = caseToolInfoPage(toolInfoPage);
            if (result == null)
               result = caseToolInfo(toolInfoPage);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.TOOL_INFO_NET: {
            ToolInfoNet toolInfoNet = (ToolInfoNet) theEObject;
            T result = caseToolInfoNet(toolInfoNet);
            if (result == null)
               result = caseToolInfo(toolInfoNet);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.TOKENS: {
            Tokens tokens = (Tokens) theEObject;
            T result = caseTokens(tokens);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.BALLOON_MARKING: {
            BalloonMarking balloonMarking = (BalloonMarking) theEObject;
            T result = caseBalloonMarking(balloonMarking);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.INPUT_SIGNALS: {
            InputSignals inputSignals = (InputSignals) theEObject;
            T result = caseInputSignals(inputSignals);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.INPUT_SIGNAL: {
            InputSignal inputSignal = (InputSignal) theEObject;
            T result = caseInputSignal(inputSignal);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.CHANNELS: {
            Channels channels = (Channels) theEObject;
            T result = caseChannels(channels);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.CHANNEL: {
            Channel channel = (Channel) theEObject;
            T result = caseChannel(channel);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.PUBLISHERS: {
            Publishers publishers = (Publishers) theEObject;
            T result = casePublishers(publishers);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.PUBLISHER: {
            Publisher publisher = (Publisher) theEObject;
            T result = casePublisher(publisher);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.SUBSCRIBERS: {
            Subscribers subscribers = (Subscribers) theEObject;
            T result = caseSubscribers(subscribers);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.SUBSCRIBER: {
            Subscriber subscriber = (Subscriber) theEObject;
            T result = caseSubscriber(subscriber);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         case PtnetPackage.TOOL_INFO_NODE: {
            ToolInfoNode toolInfoNode = (ToolInfoNode) theEObject;
            T result = caseToolInfoNode(toolInfoNode);
            if (result == null)
               result = caseToolInfo(toolInfoNode);
            if (result == null)
               result = defaultCase(theEObject);
            return result;
         }
         default:
            return defaultCase(theEObject);
      }
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>PT Marking</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>PT Marking</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePTMarking(PTMarking object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>PT Arc Annotation</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>PT Arc Annotation</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePTArcAnnotation(PTArcAnnotation object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>pnml</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>pnml</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casepnml(pnml object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Petri Net</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Petri Net</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePetriNet(PetriNet object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Page</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Page</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePage(Page object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Pn Object</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Pn Object</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePnObject(PnObject object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Name</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Name</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseName(Name object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Tool Info</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Tool Info</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseToolInfo(ToolInfo object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Label</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Label</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseLabel(Label object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Node Graphics</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Node Graphics</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseNodeGraphics(NodeGraphics object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Graphics</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Graphics</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseGraphics(Graphics object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Coordinate</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Coordinate</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseCoordinate(Coordinate object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Position</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Position</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePosition(Position object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Offset</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Offset</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseOffset(Offset object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Dimension</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Dimension</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseDimension(Dimension object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Annotation Graphics</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Annotation Graphics</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseAnnotationGraphics(AnnotationGraphics object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Fill</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Fill</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseFill(Fill object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Line</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Line</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseLine(Line object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Arc Graphics</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Arc Graphics</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseArcGraphics(ArcGraphics object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Arc</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Arc</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseArc(Arc object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Node</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Node</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseNode(Node object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Font</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Font</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseFont(Font object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Place Node</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Place Node</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePlaceNode(PlaceNode object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Transition Node</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Transition Node</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseTransitionNode(TransitionNode object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Place</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Place</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePlace(Place object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Ref Transition</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Ref Transition</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseRefTransition(RefTransition object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Transition</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Transition</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseTransition(Transition object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Ref Place</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Ref Place</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseRefPlace(RefPlace object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Attribute</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Attribute</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseAttribute(Attribute object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Annotation</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Annotation</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseAnnotation(Annotation object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Any Object</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Any Object</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseAnyObject(AnyObject object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Edge</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Edge</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseEdge(Edge object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Inhibitor Arc</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Inhibitor Arc</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseInhibitorArc(InhibitorArc object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Read Arc</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Read Arc</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseReadArc(ReadArc object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Positionable Object</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Positionable Object</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePositionableObject(PositionableObject object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Tool Info Place</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Tool Info Place</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseToolInfoPlace(ToolInfoPlace object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Tool Info Transition</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Tool Info Transition</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseToolInfoTransition(ToolInfoTransition object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Tool Info Page</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Tool Info Page</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseToolInfoPage(ToolInfoPage object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Tool Info Net</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Tool Info Net</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseToolInfoNet(ToolInfoNet object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Tokens</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Tokens</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseTokens(Tokens object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Balloon Marking</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Balloon Marking</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseBalloonMarking(BalloonMarking object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Input Signals</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Input Signals</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseInputSignals(InputSignals object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Input Signal</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Input Signal</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseInputSignal(InputSignal object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Channels</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Channels</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseChannels(Channels object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Channel</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Channel</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseChannel(Channel object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Publishers</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Publishers</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePublishers(Publishers object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Publisher</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Publisher</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePublisher(Publisher object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Subscribers</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Subscribers</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseSubscribers(Subscribers object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Subscriber</em>'.
    * <!-- begin-user-doc -->
   	 * This implementation returns null;
   	 * returning a non-null result will terminate the switch.
   	 * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Subscriber</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseSubscriber(Subscriber object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Tool Info Node</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Tool Info Node</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseToolInfoNode(ToolInfoNode object) {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch, but this is the last case anyway.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject)
    * @generated
    */
   @Override
   public T defaultCase(EObject object) {
      return null;
   }

} //PtnetSwitch
