package org.eclipse.glsp.example.javaemf.action;

import org.eclipse.glsp.server.actions.Action;
import org.eclipse.glsp.server.actions.ResponseAction;

import java.util.HashMap;
import java.util.Map;

public class TinaResponseAction extends ResponseAction {
    public static final String KIND = "TinaResponseAction";

    private String tinaResponse;


    private Map<String, String> args;

    public TinaResponseAction() {
        this("");
    }

    public TinaResponseAction(final String tinaResponse) {
        this(tinaResponse, new HashMap<>());
    }

    public TinaResponseAction(final String tinaResponse, final Map<String, String> args) {
        super(KIND);
        this.tinaResponse = tinaResponse;
        this.args = args;
    }

    public String getTinaResponse() {
        return tinaResponse;
    }

    public void setTinaResponse(String tinaResponse) {
        this.tinaResponse = tinaResponse;
    }

    public Map<String, String> getArgs() {
        return args;
    }

    public void setArgs(Map<String, String> args) {
        this.args = args;
    }
}
