package org.eclipse.glsp.example.javaemf.model;

import org.eclipse.glsp.graph.GModelIndex;
import org.eclipse.glsp.graph.GModelRoot;
import org.eclipse.glsp.server.emf.notation.EMFNotationModelIndex;
import org.eclipse.glsp.server.emf.notation.EMFNotationModelStateImpl;

import java.util.HashMap;
import java.util.Map;

public class ExtendedModelState extends EMFNotationModelStateImpl {
    // stores the IDs of pages that currently should not be displayed
    protected Map<String, Boolean> hiddenPages  = new HashMap<String,Boolean>();



    // stores the markings of the petri net during simulation
    // firing transitions during simulations does not change the initial marking attribute in the model
    protected Map<String, Integer> SimulationMarking  = new HashMap<String,Integer>();

    // stores the current values of the input signals
    protected Map<String, Boolean> InputSignalValues = new HashMap<>();

    /**/
    @Override
    protected GModelIndex getOrUpdateIndex(final GModelRoot newRoot) {
        return ExtendedIndex.getOrCreate(getRoot(), semanticIdConverter);
    }

    @Override
    public ExtendedIndex getIndex() { return (ExtendedIndex) super.getIndex(); }

    public Map<String, Boolean> getHiddenPages() {
        return hiddenPages;
    }

    public void setHiddenPages(Map<String, Boolean> hiddenPages) {
        this.hiddenPages = hiddenPages;
    }

    public Map<String, Integer> getSimulationMarking() {
        return SimulationMarking;
    }

    public void setSimulationMarking(Map<String, Integer> simulationMarking) {
        SimulationMarking = simulationMarking;
    }

    public Map<String, Boolean> getInputSignalValues() {
        return InputSignalValues;
    }

    public void setInputSignalValues(Map<String, Boolean> inputSignalValues) {
        InputSignalValues = inputSignalValues;
    }

}
