package org.eclipse.glsp.example.javaemf.operation;

import org.eclipse.glsp.server.operations.Operation;

import java.util.HashMap;
import java.util.Map;

public class AddDiNeROSTokenOperation extends Operation {
    public static final String KIND = "AddDiNeROSTokenOperation";

    private String placeId;

    private String token;

    private Map<String, String> args;

    public AddDiNeROSTokenOperation() {
        super(KIND);
    }

    public AddDiNeROSTokenOperation(String placeId){
        this(placeId, null, new HashMap<String, String>());
    }
    public AddDiNeROSTokenOperation(String placeId, String token){
        this(placeId, token, new HashMap<String, String>());
    }

    public AddDiNeROSTokenOperation(String placeId, String token, Map<String, String> args){
        super(KIND);
        this.placeId = placeId;
        this.token = token;
        this.args = args;
    }

    public String getPlaceId() {
        return placeId;
    }

    public void setPlaceId(String placeId) {
        this.placeId = placeId;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

    public Map<String, String> getArgs() {
        return args;
    }

    public void setArgs(Map<String, String> args) {
        this.args = args;
    }
}
