package org.eclipse.glsp.example.javaemf.operation;

import org.eclipse.glsp.server.operations.Operation;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SetDiNeROSTokenOperation extends Operation {
    public static final String KIND = "SetDiNeROSTokenOperation";

    private String placeId;

    private List<String> token;

    private Map<String, String> args;

    public SetDiNeROSTokenOperation() {
        super(KIND);
    }

    public SetDiNeROSTokenOperation(String placeId){
        this(placeId, new ArrayList<String>(), new HashMap<String, String>());
    }
    public SetDiNeROSTokenOperation(String placeId, List<String> token){
        this(placeId, token, new HashMap<String, String>());
    }

    public SetDiNeROSTokenOperation(String placeId, List<String> token, Map<String, String> args){
        super(KIND);
        this.placeId = placeId;
        this.token = token;
        this.args = args;
    }

    public String getPlaceId() {
        return placeId;
    }

    public void setPlaceId(String placeId) {
        this.placeId = placeId;
    }

    public List<String> getToken() {
        return token;
    }

    public void setToken(List<String> token) {
        this.token = token;
    }

    public Map<String, String> getArgs() {
        return args;
    }

    public void setArgs(Map<String, String> args) {
        this.args = args;
    }
}
