package org.eclipse.glsp.example.javaemf.operation;

import org.eclipse.glsp.server.operations.Operation;

import java.util.HashMap;
import java.util.Map;

public class SetInputSignalOperation extends Operation {
    public static final String KIND = "SetInputSignalOperation";

    private String inputSignalId;

    private boolean value;

    private Map<String, String> args;

    public SetInputSignalOperation() {
        super(KIND);
    }

    public SetInputSignalOperation(final String inputSignalId, final boolean value) {
        this(inputSignalId, value, new HashMap<>());
    }

    public SetInputSignalOperation(final String inputSignalId, final boolean value,
                                   final Map<String, String> args) {
        super(KIND);
        this.inputSignalId = inputSignalId;
        this.value = value;
        this.args = args;
    }

    public String getInputSignalId() {
        return inputSignalId;
    }

    public void setInputSignalId(String inputSignalId) {
        this.inputSignalId = inputSignalId;
    }

    public boolean isValue() {
        return value;
    }

    public void setValue(boolean value) {
        this.value = value;
    }

    public Map<String, String> getArgs() {
        return args;
    }

    public void setArgs(Map<String, String> args) {
        this.args = args;
    }
}


