package org.eclipse.glsp.example.javaemf.validators;


import org.eclipse.glsp.graph.GModelElement;
import org.eclipse.glsp.server.features.directediting.LabelEditValidator;
import org.eclipse.glsp.server.features.directediting.ValidationStatus;
import org.eclipse.glsp.server.model.GModelState;
import com.google.inject.Inject;


public class PnmlLabelEditValidator implements LabelEditValidator {

    @Inject
    protected GModelState modelState;

    @Override
    public ValidationStatus validate(final String label, final GModelElement element) {
        if (label.isEmpty()) {
            return ValidationStatus.error("Name must not be empty");
        }

        return ValidationStatus.ok();
    }

    public ValidationStatus validateArcWeight(final String label){
        int newWeight;
        try {
            newWeight = Integer.parseInt(label);
        } catch (NumberFormatException e) {
            return ValidationStatus.error("Label must be an integer.");
        }
        if(newWeight < 1){
            return ValidationStatus.error("Value must be larger than 0.");
        }
        return ValidationStatus.ok();
    }

    public ValidationStatus validateName(final String label){
        if (label.isEmpty()) {
            return ValidationStatus.error("Name must not be empty");
        }

        return ValidationStatus.ok();
    }
}

