package org.eclipse.glsp.example.javaemf.validators;

import com.google.inject.Inject;
import org.eclipse.glsp.example.javaemf.model.ExtendedModelState;
import org.eclipse.glsp.server.features.directediting.ContextEditValidator;
import org.eclipse.glsp.server.features.directediting.RequestEditValidationAction;
import org.eclipse.glsp.server.features.directediting.ValidationStatus;
import org.eclipse.glsp.server.model.GModelState;

public class SignalClauseMenuValidator implements ContextEditValidator {

    @Override
    public String getContextId() { return "signal-clause-menu"; }

    @Inject
    protected ExtendedModelState modelState;

    @Inject
    protected InputSignalValidator inputSignalValidator;

    @SuppressWarnings("checkstyle:cyclomaticComplexity")
    @Override
    public ValidationStatus validate(final RequestEditValidationAction action) {
        String text = action.getText();
        if(!inputSignalValidator.isValidCNF(text)){
            return ValidationStatus.error("Must be valid CNF");
        }

        return ValidationStatus.ok();
    }

}